var map;
var xmlreq;
var pathCoordinates = [];
var initialmarker; // Google Maps first tracker position
var lastmarker; // Google Maps last tracker position
var direction;
var dts; // Timestamp of the MPEG TS Stream. Store the last time mark of the GPS/Gyro data
var duration; // Duration of the current track
var total_duration; // Duration of the current sequence (a consecutive group of tracks)
var px_per_sec; // Number of pixels per seconds. Multiply this value with the current timestamp in order to get the position of the car sprite
var last_video_update; // Timestamp of the video, relative to the current track
var current_pos_global; // Timestamp of the video, relative to the current sequence
var offset_current_video; // Timestamp of the beginning of the current track relative to the current sequence : current_pos_global = offset_current_video + last_video_update;
var playlist_pos; // Position in the ts_duration[]/ts_duration[]/ts_path[] array of the current track
var playlist_first_pos; // Position in the ts_duration[]/ts_duration[]/ts_path[] array of the first track in the current sequence
var tracksize = 645; // Size of the bar where we put the car sprite
var isSeeking = 0;
var eventWatchdog, watchdog_offset;
var trackbutton, trackbar, trackbuttonX = 0, isTrackButtonMoving = 0;
var video, videoElement;
var sensor_area, sensor_area_ctx;
var gyroXX, gyroXY, gyroYX, gyroYY, gyroZX, gyroZY;
var posX;

//  103.3.20 arthur 宣告 nowPath
var nowPath;

//record speed
var current_speed;

//deal with time track problem
var lastEnd;

//for fiel list display
var titleIndex = [];
var indexOpen = [];

var titleIndex_disk = [];
var indexOpen_disk = [];

//Snapshot
var canvas;
var context;
var w, h, ratio;
var firstSnap;
var snapShot_number;
var hint_time;

//Map轉向圖
var image_n = new google.maps.MarkerImage('http://www.fuho.com.tw/16picture/n.png',
                                          // This marker is 32 pixels wide by 32 pixels tall.
                                          new google.maps.Size(32, 32),
                                          new google.maps.Point(0, 0),
                                          new google.maps.Point(16, 16));

var image_e = new google.maps.MarkerImage('http://www.fuho.com.tw/16picture/e.png',
                                          // This marker is 32 pixels wide by 32 pixels tall.
                                          new google.maps.Size(32, 32),
                                          new google.maps.Point(0, 0),
                                          new google.maps.Point(16, 16));

var image_w = new google.maps.MarkerImage('http://www.fuho.com.tw/16picture/w.png',
                                          // This marker is 32 pixels wide by 32 pixels tall.
                                          new google.maps.Size(32, 32),
                                          new google.maps.Point(0, 0),
                                          new google.maps.Point(16, 16));

var image_s = new google.maps.MarkerImage('http://www.fuho.com.tw/16picture/s.png',
                                          // This marker is 32 pixels wide by 32 pixels tall.
                                          new google.maps.Size(32, 32),
                                          new google.maps.Point(0, 0),
                                          new google.maps.Point(16, 16));

var image_sw = new google.maps.MarkerImage('http://www.fuho.com.tw/16picture/sw.png',
                                           // This marker is 32 pixels wide by 32 pixels tall.
                                           new google.maps.Size(32, 32),
                                           new google.maps.Point(0, 0),
                                           new google.maps.Point(16, 16));

var image_se = new google.maps.MarkerImage('http://www.fuho.com.tw/16picture/se.png',
                                           // This marker is 32 pixels wide by 32 pixels tall.
                                           new google.maps.Size(32, 32),
                                           new google.maps.Point(0, 0),
                                           new google.maps.Point(16, 16));

var image_nw = new google.maps.MarkerImage('http://www.fuho.com.tw/16picture/nw.png',
                                           // This marker is 32 pixels wide by 32 pixels tall.
                                           new google.maps.Size(32, 32),
                                           new google.maps.Point(0, 0),
                                           new google.maps.Point(16, 16));

var image_ne = new google.maps.MarkerImage('http://www.fuho.com.tw/16picture/ne.png',
                                           // This marker is 32 pixels wide by 32 pixels tall.
                                           new google.maps.Size(32, 32),
                                           new google.maps.Point(0, 0),
                                           new google.maps.Point(16, 16));

var image_nne = new google.maps.MarkerImage('http://www.fuho.com.tw/16picture/nne.png',
	                                        // This marker is 32 pixels wide by 32 pixels tall.
	                                        new google.maps.Size(32, 32),
	                                        new google.maps.Point(0, 0),
	                                        new google.maps.Point(16, 16));

var image_nee = new google.maps.MarkerImage('http://www.fuho.com.tw/16picture/nee.png',
	                                        // This marker is 32 pixels wide by 32 pixels tall.
	                                        new google.maps.Size(32, 32),
	                                        new google.maps.Point(0, 0),
	                                        new google.maps.Point(16, 16));

var image_sse = new google.maps.MarkerImage('http://www.fuho.com.tw/16picture/sse.png',
	                                        // This marker is 32 pixels wide by 32 pixels tall.
	                                        new google.maps.Size(32, 32),
	                                        new google.maps.Point(0, 0),
	                                        new google.maps.Point(16, 16));

var image_see = new google.maps.MarkerImage('http://www.fuho.com.tw/16picture/see.png',
	                                        // This marker is 32 pixels wide by 32 pixels tall.
	                                        new google.maps.Size(32, 32),
	                                        new google.maps.Point(0, 0),
	                                        new google.maps.Point(16, 16));

var image_nnw = new google.maps.MarkerImage('http://www.fuho.com.tw/16picture/nnw.png',
	                                        // This marker is 32 pixels wide by 32 pixels tall.
	                                        new google.maps.Size(32, 32),
	                                        new google.maps.Point(0, 0),
	                                        new google.maps.Point(16, 16));

var image_nww = new google.maps.MarkerImage('http://www.fuho.com.tw/16picture/nww.png',
	                                        // This marker is 32 pixels wide by 32 pixels tall.
	                                        new google.maps.Size(32, 32),
	                                        new google.maps.Point(0, 0),
	                                        new google.maps.Point(16, 16));

var image_ssw = new google.maps.MarkerImage('http://www.fuho.com.tw/16picture/ssw.png',
	                                        // This marker is 32 pixels wide by 32 pixels tall.
	                                        new google.maps.Size(32, 32),
	                                        new google.maps.Point(0, 0),
	                                        new google.maps.Point(16, 16));

var image_sww = new google.maps.MarkerImage('http://www.fuho.com.tw/16picture/wsw.png',
	                                        // This marker is 32 pixels wide by 32 pixels tall.
	                                        new google.maps.Size(32, 32),
	                                        new google.maps.Point(0, 0),
	                                        new google.maps.Point(16, 16));
var angle;
var latlng;
var markers = [];
var longitude;
var latitude;
var poly;               //原本沒宣告  但在vivi的10.7仍會error?

//修正旋轉問題
var last_lon, last_lat;     //record last position value
var firstCarPic;            //record first car icon
var last_img;               //record last car icon

//倒播處理
var oneTime;                //unsolved

//openFile
var handlePause;        //pause失效問題
var playFileNow;        //open file後又選取檔案清單的話true
var returnSD;           //又去點選檔案列表的檔案項目
var OpenDiskFolder=false;           //開啓本機檔案
var openAgain;          //處理open file後點選cancel之後影片無法pause的問題

//語系
var language_index;

var xLanguage;

var en_filelist = "SD-card File List :";
var fr_filelist = "Liste des fichiers carte SD :";

var en_speed = "Speed";
var fr_speed = "Vitesse";

var en_x = "X : Left / Right";
var fr_x = "X : Gauche / Droit";

var en_y = "Y : Front / Back";
var fr_y = "Y : Avant / Arrière";

var en_z = "Z : Up / Down";
var fr_z = "Z : Haut / Bas";

var en_sdCard ="SD Card";
var fr_sdCard ="Carte SD";

var en_open = "Disk";
var fr_open = "Disque";

var en_openfolder = "Open File ...";//"Open Folder ...";//"Open File ...";
var fr_openfolder = "Ouvrir...";

var en_diskList = "Disk List";
var fr_diskList = "Disque Liste";

var selectTS;

var disklist_clear=false;

// 20140502 willy build80 ---JS參數---
var FStaut=false;//檢查檔案是否備份完成
var Btn_Open=false;//判斷是否有開檔（所有haveChoose替換成Btn_Open）
var OpenFileStatus=false;//判斷是否有啟動openfile function
var doCancel = false;//判斷啟動openfile function是否選擇Cancel
var firstopen = true;//判斷是否第一次開檔
var videobacktrack=false;// 判斷影片是否為倒播狀態
var videobacktrack_end=false;// 判斷影片是否為倒播到目錄的頭
var videolastTrack=false;// 判斷影片是否直接換到上一個
var videobackward=false;// 判斷影片是否因為手動倒播換到上一個
var oldtime=0;// 計算時間差
var deferred_seek=0;// 影片初始時間
// 20140502 willy ------

//2014.3.23 小視窗碼流參數
var video_src;
var initPath;
var noSpeed;
var subVideo, subVideoElement;
var setSubPath;
var sub_canvas;
var sub_context;
var sub_w, sub_h, sub_ratio;
var sub_firstSnap;
var sub_snapShot_number;

var screenW;
var screenH;
var isFullScreen;
var isRestoreScreen;
var isPause;
var isPlay;
var isFullScreen1;
var isMouseUp;
var isMouseDown;
var isClickToNextFile;

var createSubView;
var getMainView;

var typeEO5;
var osxVer;
var osx10_9;
var isFileSelect;
var isPlayVideo;
var SDCard_plugging;
var isOpenFile;
var openFile_loseUSB;

var isBtnCardList;
var isBtnDiskList;

var playRate_25;
var playRate_5;
var playRate_1;
var playRate_2;
var playRate_4;


//103.3.22 arthur GPS兩點超過一公里將重繪路線
//var isResetMap = false;
var tmp_lon=0;
var tmp_lat=0;
var tmp_km=0;
var EARTH_RADIUS = 6378.137;

// 20140430 willy build80 ---判斷全螢幕---
var hasfullmain=true;
var hasfullsub=false;
// 20140430 willy ------

/* ======= Function ======== */

function rad(d)
{
    return d * Math.PI / 180.0;
}

function getDistance(lat1,lng1,lat2,lng2)//計算GPS兩點直線距離(KM)
{
    var radLat1 = rad(lat1);
    var radLat2 = rad(lat2);
    var a = radLat1 - radLat2;
    var b = rad(lng1) - rad(lng2);
    var s = 2 * Math.asin(Math.sqrt(Math.pow(Math.sin(a/2),2) + Math.cos(radLat1)*Math.cos(radLat2)*Math.pow(Math.sin(b/2),2)));
    s = s * EARTH_RADIUS;
    s = Math.round(s * 10000) / 10000;
    return s;
}

function parse_xml(xmldata)
{
    //return; //20140320 林宏 build45 Test--------------
    // We shoulnd't encounter this tag since we avoid generating useless request
    var ischange = xmldata.getElementsByTagName("nochange");
    if(ischange.length > 0)
        return;     // We don't have any fresh update from the GPS, bail out

    // Parse the XML document returned by the main software and update the various text fields
    dts = xmldata.getElementsByTagName("dts")[0].firstChild.nodeValue;
    var sv = document.getElementById("gps_speed");
    sv.innerHTML = xmldata.getElementsByTagName("speed")[0].firstChild.nodeValue;
    sv = document.getElementById("gps_pos");
    sv.innerHTML = xmldata.getElementsByTagName("pos")[0].firstChild.nodeValue;
    sv = document.getElementById("gps_time");
    sv.innerHTML = xmldata.getElementsByTagName("time")[0].firstChild.nodeValue;
    sv = document.getElementById("gps_date");
    sv.innerHTML = xmldata.getElementsByTagName("date")[0].firstChild.nodeValue;

    var latlng = new google.maps.LatLng(xmldata.getElementsByTagName("longitude")[0].firstChild.nodeValue,  xmldata.getElementsByTagName("latitude")[0].firstChild.nodeValue);

    //car角度
    angle = xmldata.getElementsByTagName("angle")[0].firstChild.nodeValue;
    //var speed = xmldata.getElementsByTagName("speed")[0].firstChild.nodeValue;        //other way to solving icon spin problem

    longitude = xmldata.getElementsByTagName("longitude")[0].firstChild.nodeValue;
    latitude =  xmldata.getElementsByTagName("latitude")[0].firstChild.nodeValue;

    //2014.3.23 沒有時速顯示0
    noSpeed = xmldata.getElementsByTagName("speed")[0].firstChild.nodeValue;
    if(noSpeed =="---" )
    {
        var sv = document.getElementById("gps_speed");
        sv.innerHTML = "0";

        //        var gFntSz = "20pt" ;
        //        var gps_pos = document.getElementById("gps_pos");
        //        gps_pos.innerHTML = "0";
        //        gps_pos.style.fontSize = gFntSz;
    }


    //設定方向改變threshold
    var direction_difference = Math.abs(longitude-last_lon) + Math.abs(latitude-last_lat);
    last_lat = latitude;
    last_lon = longitude;

    if(direction_difference > 0.00005)      //位置變動幅度大才修改方向資料
    {
        sv = document.getElementById("direction_str");
        sv.innerHTML = xmldata.getElementsByTagName("direction_str")[0].firstChild.nodeValue;
        // Rotate the compass
        document.getElementById('pointer').style.webkitTransform = xmldata.getElementsByTagName("direction")[0].firstChild.nodeValue;
    }

    posX = current_pos_global * px_per_sec;
    // 20140331 OOOOO build70 ---校正結束時bar的顯示---
    if(current_pos_global <= total_duration)
    {
        trackbutton.style.webkitTransform = "translateX("+posX+"px)";
    }

    // Gyro. size=250x80
    // Y = 80 ; middle = 80/2 = 40
    sensor_area_ctx.strokeStyle = "#FF8F19";        //橘
    sensor_area_ctx.beginPath();
    sensor_area_ctx.moveTo(gyroXX, gyroXY);
    gyroXY = 40 - 20*(xmldata.getElementsByTagName("gyroX")[0].firstChild.nodeValue);
    gyroXX++;
    sensor_area_ctx.lineTo(gyroXX, gyroXY);
    sensor_area_ctx.closePath();
    sensor_area_ctx.stroke();
    sensor_area_ctx.lineWidth = 8;

    sensor_area_ctx.strokeStyle = "#A2B8D0";        //灰
    sensor_area_ctx.beginPath();
    sensor_area_ctx.moveTo(gyroYX, gyroYY);
    gyroYY = 40 - 20*(xmldata.getElementsByTagName("gyroY")[0].firstChild.nodeValue);
    gyroYX++;
    sensor_area_ctx.lineTo(gyroYX, gyroYY);
    sensor_area_ctx.closePath();
    sensor_area_ctx.stroke();
    sensor_area_ctx.lineWidth = 8;

    sensor_area_ctx.strokeStyle = "#EFC9A1";        //淺橘
    sensor_area_ctx.beginPath();
    sensor_area_ctx.moveTo(gyroZX, gyroZY);
    gyroZY = 40 - 20*(xmldata.getElementsByTagName("gyroZ")[0].firstChild.nodeValue);
    gyroZX++;
    sensor_area_ctx.lineTo(gyroZX, gyroZY);
    sensor_area_ctx.closePath();
    sensor_area_ctx.stroke();
    sensor_area_ctx.lineWidth = 8;

    //Refresh Gyroscope
    if(gyroZX >= 300 || gyroYX >= 300 || gyroXX >= 300)
        clearGyro();

    // Google Maps
    if(!map)
    {
        // Google Maps wasn't initialized yet. Let's create it.
        var myOptions = {
        center: latlng,
        zoom: 16,
        mapTypeId: google.maps.MapTypeId.ROADMAP
        };
        map = new google.maps.Map(document.getElementById("map_canvas"),
                                  myOptions);
    }
    if(!initialmarker)  // Is the first GPS data ?
    {
        // Yes, create the polyline structure and place a marker on this position

        // We create pathCoordinates as an MVCArray so we can
        // manipulate it using the insertAt() method
        pathCoordinates = new google.maps.MVCArray();

        var polyOptions = {
        path: pathCoordinates,
        strokeColor: '#FA0300',
        strokeOpacity:1,
        strokeWeight: 5
        };

        poly = new google.maps.Polyline(polyOptions);
        //103.3.23 arthur 第一次取GPS 無資料 避免從位置0,0拉線去當前位置
        if((longitude == 0.0) && (latitude == 0.0))
        {
            deleteOverlays();
            replay_clearPath();
            return;
        }

        initialmarker = new google.maps.Marker({position: latlng, map: map, animation: google.maps.Animation.DROP});    //map revised

        //Map
        markers.push(initialmarker);

        poly.setMap(map);
        //        //103.3.23 arthur 第一次取GPS 無資料 避免從位置0,0拉線去當前位置
        //        if((longitude == 0.0) && (latitude == 0.0))
        //        {
        //            deleteOverlays();
        //            replay_clearPath();
        //            return;
        //        }

    }
    else
    {
        // No, delete the previous marker, and place the new one
        if(lastmarker)
            lastmarker.setMap(null);
        lastmarker = new google.maps.Marker({position: latlng, map: map});
        //marker.setTitle(name);
        //var newpos = new google.maps.LatLng( xmldata.getElementsByTagName("longitude")[0].firstChild.nodeValue,  xmldata.getElementsByTagName("latitude")[0].firstChild.nodeValue);
        //map.setCenter(newpos);

        //map
        if(direction_difference > 0.00005 || firstCarPic == false)  //設定方向改變threshold
        {

            if (angle > 349) {
                lastmarker.setIcon(image_n);
                last_img = image_n;
            } else if (angle > 326) {
                lastmarker.setIcon(image_nnw);
                last_img = image_nnw;
            } else if (angle > 304) {
                lastmarker.setIcon(image_nw);
                last_img = image_nw;
            } else if (angle > 281) {
                lastmarker.setIcon(image_nww);
                last_img = image_nww;
            } else if (angle > 259) {
                lastmarker.setIcon(image_w);
                last_img = image_w;
            } else if (angle > 236) {
                lastmarker.setIcon(image_sww);
                last_img = image_sww;
            } else if (angle > 214) {
                lastmarker.setIcon(image_sw);
                last_img = image_sw;
            } else if (angle > 191) {
                lastmarker.setIcon(image_ssw);
                last_img = image_ssw;
            } else if (angle > 169) {
                lastmarker.setIcon(image_s);
                last_img = image_s;
            } else if (angle > 146) {
                lastmarker.setIcon(image_sse);
                last_img = image_sse;
            } else if (angle > 124) {
                lastmarker.setIcon(image_se);
                last_img = image_se;
            } else if (angle > 101) {
                lastmarker.setIcon(image_see);
                last_img = image_see;
            } else if (angle > 79) {
                lastmarker.setIcon(image_e);
                last_img = image_e;
            } else if (angle > 56) {
                lastmarker.setIcon(image_nee);
                last_img = image_nee;
            } else if (angle > 34) {
                lastmarker.setIcon(image_ne);
                last_img = image_ne;
            } else if (angle > 11) {
                lastmarker.setIcon(image_nne);
                last_img = image_nne;
            } else {
                lastmarker.setIcon(image_n);
                last_img = image_n;
            }

            firstCarPic = true;
        }
        else
            lastmarker.setIcon(last_img);

        markers.push(lastmarker);


        //103.3.23 arthur 繪製過程中如果發生讀不到ＧＰＳ把上一個值從設一次
        if((longitude == 0.0) && (latitude == 0.0))
        {
            latlng.longitude = tmp_lat;
            latlng.latitude = tmp_lat ;
            return;
        }

        //103.3.22 arthur 重繪路線
        tmp_km = getDistance(tmp_lon,tmp_lat,last_lon,last_lat);
        tmp_lat=last_lat;
        tmp_lon=last_lon;
        if(tmp_km>1)
        {
            reset_map();
            return;
        }


        //Other method : if speed no change, keep the same picture
        /*if(speed == 000)
         {
         lastmarker.setIcon(image_n);
         }
         else if(speed == 001)
         {
         lastmarker.setIcon(image_n);

         }
         else if(speed == 002)
         {
         lastmarker.setIcon(image_n);
         }*/
    }

    if((latlng.longitude == 0.0) && (latlng.latitude == 0.0))
        return; // invalid GPS data

    // Update the polyline and recenter the map
    poly.getPath().push(latlng);
    map.panTo(latlng);
}


// 清除GSeneor
function clearGyro()
{
    sensor_area = document.getElementById("sensor-data");
    sensor_area_ctx = sensor_area.getContext("2d");

    sensor_area.width = sensor_area.width;      //Clear canvas context
    gyroZX = 0;
    gyroYX = 0;
    gyroXX = 0;
}


//map function
function setAllMap(map)
{
    for (var i = 0; i < markers.length; i++) {
        markers[i].setMap(map);
    }
}

function clearOverlays()
{
    setAllMap(null);
}

function deleteOverlays()
{
    clearOverlays();
    markers = [];
}


function seek_clearPath()
{
    var len = poly.getPath().getLength();
	for (var i=0; i< len; i++)
    {
		poly.getPath().removeAt(1);
	}
}

function replay_clearPath()
{
    var len = poly.getPath().getLength();
	for (var i=0; i< len; i++)
    {
		poly.getPath().removeAt(0);
	}
}


//103.3.23 arthur 修改 isResetMap: 是否重置地圖
function reset_map()
{
    //103.3.22 arthur 重繪路線 修改
    //        var xmlreqDebug;
    //        xmlreqDebug = new XMLHttpRequest();
    //        xmlreqDebug.open("GET", url_debug+"reset_map !!!!!!!", false);
    //        xmlreqDebug.send(null);
    //


    try
    {
        deleteOverlays();
        replay_clearPath();

        if(lastmarker)
        {
            lastmarker.setMap(null);
            lastmarker = null;
        }

        if(initialmarker)
        {
            initialmarker.setMap(null);
            initialmarker = null;
        }
        if(pathCoordinates)
        {
            pathCoordinates.length = 0;
            pathCoordinates = null;
        }
        clearGyro();
    }
    catch(e)
    {
        var debugxml = new XMLHttpRequest();
        debugxml.open("GET", url_debug+"reset_map_error:"+e, false);
        debugxml.send();
    }

    //        isResetMap = false;

}
//map function

function event_seeked()
{
    try
    {
        // 20140430 willy build80 ---判斷由哪個主導拖拉bar控制影像同步---
        if(hasfullsub)
            return;

        hideLoadWeb();// 20140331 willy build69 ---隱藏loading圖示---
        //Light_Play();
        //video_play();
        //console.log("seek.");
        window.clearTimeout(eventWatchdog);
        //console.log("play.");
        videoElement.play();

        try{
            subVideoElement.currentTime=videoElement.currentTime;// 20140430 willy build80 ---拖拉bar的影像同步問題---
            subVideoElement.play();//2014.3.24
        }
        catch(e)
        {}

        isSeeking = 0;
    }
    catch(e)
    {
        var debugxml = new XMLHttpRequest();
        debugxml.open("GET", url_debug+"event_seeked_error:"+e, false);
        debugxml.send();
    }
}

function sub_event_seeked()
{
    try
    {
        // 20140430 willy build80 ---判斷由哪個主導拖拉bar控制影像同步---
        if(hasfullmain)
            return;

        hideLoadWeb();// 20140331 willy build69 ---隱藏loading圖示---
        //Light_Play();
        //video_play();
        //console.log("seek.");
        window.clearTimeout(eventWatchdog);
        //console.log("play.");
        videoElement.play();

        try{
            videoElement.currentTime=subVideoElement.currentTime;// 20140430 willy build80 ---拖拉bar的影像同步問題---
            subVideoElement.play();//2014.3.24
        }
        catch(e)
        {}

        isSeeking = 0;
    }
    catch(e)
    {
        var debugxml = new XMLHttpRequest();
        debugxml.open("GET", url_debug+"event_seeked_error:"+e, false);
        debugxml.send();
    }
}

function seek_watchdog()
{
    //console.log("Watchdog triggered");

    if(playlist_pos == -1)
    {
        video_create(defaultVideo, url_open_file + defaultVideo, watchdog_offset, true);
    }
    else
    {
        video_create(ts_path[playlist_pos], url_open_file + ts_path[playlist_pos], watchdog_offset, true);
    }
}

function seek_video(videoElementParam, offset)
{
    try
    {
        // If we don't pause()/play(), the browser may hang (sometimes)
        var wasSeeking = isSeeking;
        isSeeking = 1;
        videoElementParam.pause();
        var roundedoffset = Math.round(offset / 0.320) * 0.320;
        //console.log("Seeking at %f", roundedoffset);
        watchdog_offset = offset;
        if(!wasSeeking)
            eventWatchdog = window.setTimeout(seek_watchdog, 1300);

        //if(roundedoffset <= videoElementParam.duration - 1)
        videoElementParam.currentTime = roundedoffset;

        //        subVideoElement.pause();
        //        subVideoElement.currentTime = roundedoffset;
        //else
        //videoElementParam.currentTime = videoElementParam.duration - 0.5;

        //console.log("Waiting for event seeked");

        //103.3.23 arthur 拉動 seek 重置地圖
        //    var xmlreqDebug;
        //    xmlreqDebug = new XMLHttpRequest();
        //    xmlreqDebug.open("GET", url_debug+"seek重置地圖!!!!!!!!!!!!!", false);
        //    xmlreqDebug.send(null);
        //reset_map(); // 20140331 willy build68 ---不會進來,先註解---

        var xmlreqDebug = new XMLHttpRequest();
        xmlreqDebug.open("GET", url_debug+"seek_video_videoElementParam", false);
        xmlreqDebug.send(null);


    }
    catch(e)
    {
        var xmlreqDebug = new XMLHttpRequest();
        xmlreqDebug.open("GET", url_debug+"seek_video_Error:"+e, false);
        xmlreqDebug.send(null);
    }
}

// 20140401 willy build72 ---seek_sub_video由主碼流直接控制即可(seek_video)---
/*
 //2014.3.23 小碼流拖拉
 function seek_sub_video(sub_videoElementParam, offset)
 {
 // 20140326 willy build59 ---E05不會有小碼流的部分,用try-catch讓後續的動作維持正常---
 try
 {
 var xmlreqDebug = new XMLHttpRequest();
 xmlreqDebug.open("GET", url_debug+"seek_sub_video", false);
 xmlreqDebug.send(null);

 var wasSeeking = isSeeking;
 isSeeking = 1;
 sub_videoElementParam.pause();
 var roundedoffset = Math.round(offset / 0.320) * 0.320;

 watchdog_offset = offset;
 if(!wasSeeking)
 eventWatchdog = window.setTimeout(seek_watchdog, 1300);
 sub_videoElementParam.currentTime = roundedoffset;
 }
 catch(e)
 {

 var xmlreqDebug = new XMLHttpRequest();
 xmlreqDebug.open("GET", url_debug+"seek_sub_video_Error:"+e, false);
 xmlreqDebug.send(null);

 }

 }
 */
// 20140401 willy ------

function event_playing()
{
    try
    {
        var defer0921 = new XMLHttpRequest();
        defer0921.open("GET", url_debug+"EventPlaying", false);
        defer0921.send(null);
        // 20140402 willy build72 ---控制播放燈號---
        if(videobacktrack)
        {
            Light_Backtrack();
        }
        else
        {
            Light_Play();
        }
        // 20140402 willy ------

        if(deferred_seek)
        {
            seek_video(videoElement, deferred_seek);

            // 20140401 willy build72 ---seek_sub_video由主碼流直接控制即可---
            //2014.3.23
            //seek_sub_video(subVideoElement, deferred_seek);
            //        var defer1 = new XMLHttpRequest();
            //        defer1.open("GET", url_debug+"deferred_seek_sub", false);
            //        defer1.send(null);
            deferred_seek = 0;

        }

    }
    catch(e)
    {
        var defer0921 = new XMLHttpRequest();
        defer0921.open("GET", url_debug+"Event_Playing_Error:"+e, false);
        defer0921.send(null);
    }
}

// This function is a called directly by the video player itself while the video is playing
// It seems to fire an event every ~200ms
var vsrc="";
function video_timeupdate()
{
    try
    {
        getUSBState();
        get_USBLose_OpenFile_state();
        if(SDCard_plugging == "1" && !isOpenFile)
        {
            cancelAPP();
        }
        if(SDCard_plugging == "1" && isBtnCardList && !isOpenFile)
        {
            cancelAPP();
        }

        var currentTimeStamp;
        if(videoElement.currentTime >= hint_time+3)
        {
            clearHint();
        }

        if(videoElement.duration>120 && videoElement.currentSrc!=vsrc)
        {
            //showLoadWeb();
            //video_ended();
            vsrc=videoElement.currentSrc;
            var parameter = {'SDFilePath':videoElement.currentSrc,'type':'3','SDFileName':videoElement.currentSrc};
            //video_ended();
            var result = native.ocMethod(parameter);
            //video_ended();
            return;
        }

        handleOpening();

        // 20140401 willy build72 ---讓SDCard與Disk的檔案共用---
        currentVideoTimeStamp = videoElement.currentTime;

        if(isFullScreen && !isRestoreScreen)
        {
            window.focus();
        }

        if(isRestoreScreen && !isFullScreen)
        {
            window.focus();
        }


        /*
         xmlreqDebug = new XMLHttpRequest();
         xmlreqDebug.open("GET", url_debug+"video_timeupdate_direction:"+direction+"_playbackRate:"+videoElement.playbackRate, false);
         xmlreqDebug.send(null);
         */
        /*
         // 20140403 willy build72 ---控制播放燈號---
         if(videobacktrack)
         {
         Light_Backtrack();
         }
         else
         {
         Light_Play();
         }
         // 20140402 willy ------
         */
        //20140402 willy build72 ---順著倒播,這邊還不是源頭---
        if(videoElement.playbackRate==1 && videobacktrack)
        {
            Light_Backtrack();
            direction = -1;
            videoElement.playbackRate=direction;
            try
            {
                subVideoElement.playbackRate=direction;
            }
            catch(e)
            {}
        }
        //20140402 willy ------

        // 判斷是否是開檔
        if(Btn_Open==true)//DiskFile
        {
            //倒播處理
            if(currentVideoTimeStamp < 0.25 && direction == -1)
            {

                // 20140329 willy build63 ---燈號控制(暫停)---
                videoElement.pause();
                try{
                    subVideoElement.pause();
                }
                catch(e)
                {}
                Light_Pause();
                direction = 1;
            }

            compute_totaltime();
            compute_current_offset();

            seektimeupdate();// 20140328 willy build63 ---計算完畢再作顯示---

        }
        else// SDCardFile
        {
            //倒轉到影片最開頭
            if(currentVideoTimeStamp < 0.25 && videobacktrack)//&& direction == -1)
            {
                if(playlist_pos == 0)
                {
                    // 20140329 willy build63 ---燈號控制(暫停)---
                    videoElement.pause();
                    try
                    {
                        subVideoElement.pause();
                    }
                    catch(e)
                    {
                    }
                    Light_Pause();
                    direction = 1;
                }
                else
                {
                    direction = -1;
                    video_ended();
                    return;
                }

            }

            totalTime();
        }

        if(typeof(ts_duration) != 'undefined')
        {
            //最後一部影片的結尾處理
            if(playlist_pos == ts_duration.length-1)
            {
                if(videoElement.currentTime+0.25 >= videoElement.duration)
                {
                    lastEnd = true;
                    video_ended();

                    return;
                }
            }
        }

        // If the user move the track button, don't bother to launch a request. It would make the move choppy
        if(isTrackButtonMoving)
            return;

        if(isSeeking)
        {
            return;
        }

        if((currentVideoTimeStamp < last_video_update) || (currentVideoTimeStamp > last_video_update + 3))
        {
            //console.log("Abort and seek");
            // Try to cancel the current request
            // xmlreq.abort();
        }
        else
        {
            if(currentVideoTimeStamp - 1 < last_video_update)    // We have a GPS record each second, but we're called much more often
            {
                return;                        // Less than a second, skip altogether the request
            }
        }

        last_video_update = currentVideoTimeStamp;
        current_pos_global = offset_current_video + last_video_update;

        if(last_video_update+1.0 >= videoElement.duration)      //最後一秒不去要GPS
        {
            video_ended();

            //2014.4.21
            if(videoElement.duration ==18.83333396911621) // 1/1 16:53:34
            {
                trackbutton.style.webkitTransform = "translateX("+tracksize+"px)";
            }
            return;
        }
        // 20140401 willy build71 ---檔案播完直接換結束---
        else if(current_pos_global+1 > total_duration)
        {
            video_ended();

            //2014.4.21
            trackbutton.style.webkitTransform = "translateX("+tracksize+"px)";
            return;
        }
        // 20140401 willy ------

        xmlreq = new XMLHttpRequest();

        xmlreq.open("GET", url_next_frame+currentVideoTimeStamp+"-"+nowPath, false);
        xmlreq.send(null);
        parse_xml(xmlreq.responseXML);

        // 20140401 willy ------

        isPause = false;
        isFileSelect = false;
        isClickToNextFile = false;
        isPlayVideo = false;
        isMouseUp = false;

    }
    catch(e)
    {
        var xmlreqDebug = new XMLHttpRequest();
        xmlreqDebug.open("GET", url_debug+"video_timeupdate_error:"+e, false);
        xmlreqDebug.send(null);
    }
}
/*
 //load SD Card List for timeupdatem function
 function SDCardFile()
 {
 currentVideoTimeStamp = videoElement.currentTime;

 try
 {
 xmlreqDebug = new XMLHttpRequest();
 xmlreqDebug.open("GET", url_debug+"SDCard", false);
 xmlreqDebug.send(null);

 //倒轉到影片最開頭
 if(currentVideoTimeStamp < 0.25 && direction == -1)
 {
 if(playlist_pos == 0)       //first video
 {
 videoElement.pause();

 xmlreqDebug = new XMLHttpRequest();
 xmlreqDebug.open("GET", url_debug+"back222", false);
 xmlreqDebug.send(null);

 // 20140329 willy build63 ---燈號控制(暫停)---
 Light_Pause();

 direction = 1;
 }
 else       //改成會一直持續倒播，目前是當下影片播到開頭就暫停
 {
 oneTime = true;

 xmlreqDebug = new XMLHttpRequest();
 xmlreqDebug.open("GET", url_debug+"back333", false);
 xmlreqDebug.send(null);


 playlist_pos--;

 if(OpenDiskFolder==true)
 {
 var tmpFile = document.getElementById(ts_display[playlist_pos]+"_disk");
 tmpFile.setAttribute('class', 'selected');
 tmpFile = document.getElementById(ts_display[playlist_pos+1]+"_disk");
 tmpFile.setAttribute('class', 'unselected');

 }
 else
 {
 var tmpFile = document.getElementById(ts_display[playlist_pos]);
 tmpFile.setAttribute('class', 'selected');
 tmpFile = document.getElementById(ts_display[playlist_pos+1]);
 tmpFile.setAttribute('class', 'unselected');

 }
 //
 //                 var tmpFile = document.getElementById(ts_display[playlist_pos]);
 //                 tmpFile.setAttribute('class', 'selected');
 //                 tmpFile = document.getElementById(ts_display[playlist_pos+1]);
 //                 tmpFile.setAttribute('class', 'unselected');
 //
 //
 //                 if(OpenDiskFolder==false)
 //                 {
 //                 // folderSelect(playlist_pos, false);
 //                 }
 //
 compute_totaltime();
 compute_current_offset();

 videoElement.pause();

 // 20140329 willy build63 ---燈號控制(暫停)---
 Light_Pause();

 //video_create(ts_path[playlist_pos++], url_open_file+ts_path[playlist_pos], ts_duration[playlist_pos]-2, false);

 }
 }

 //9.20
 totalTime();

 //9.12  map 103.3.23 arthur 取消
 //        if(videoElement.currentTime == 0 && direction == -1)
 //        {
 //            deleteOverlays();
 //            replay_clearPath();
 //
 //        }

 //9.12  map 103.3.23 arthur 取消
 //        if(longitude == 0.0 && latitude == 0.0)
 //        {
 //            //deleteOverlays();
 //            reset_map();
 //        }
 if(typeof(ts_duration) != 'undefined')
 {
 //最後一部影片的結尾處理
 if(playlist_pos == ts_duration.length-1)
 {
 if(videoElement.currentTime+0.25 >= videoElement.duration)
 {
 lastEnd = true;
 video_ended();

 return;
 }
 }


 }
 // If the user move the track button, don't bother to launch a request. It would make the move choppy
 if(isTrackButtonMoving)
 return;

 if(isSeeking)
 {
 return;
 }
 if((currentVideoTimeStamp < last_video_update) || (currentVideoTimeStamp > last_video_update + 3))
 {
 //console.log("Abort and seek");
 // Try to cancel the current request
 // xmlreq.abort();
 }
 else
 {
 if(currentVideoTimeStamp - 1 < last_video_update)    // We have a GPS record each second, but we're called much more often
 {
 return;                        // Less than a second, skip altogether the request
 }
 }

 last_video_update = currentVideoTimeStamp;
 current_pos_global = offset_current_video + last_video_update;

 if(last_video_update+1.0 >= videoElement.duration)      //最後一秒不去要GPS
 {
 video_ended();
 return;
 }
 // 20140401 willy build71 ---檔案播完直接換結束---
 else if(current_pos_global+1 > total_duration)
 {
 video_ended();
 return;
 }
 // 20140401 willy ------

 xmlreq = new XMLHttpRequest();

 //      103.3.20 arthur url_next_frame js
 //      xmlreq.open("GET", url_next_frame+currentVideoTimeStamp, false);
 xmlreq.open("GET", url_next_frame+currentVideoTimeStamp+"-"+nowPath, false);
 xmlreq.send(null);
 parse_xml(xmlreq.responseXML);
 }
 catch(e)
 {
 xmlreqDebug = new XMLHttpRequest();
 xmlreqDebug.open("GET", url_debug+"SDCard_Error:"+e, false);
 xmlreqDebug.send(null);
 }

 }
 */
//9.20
// 單一檔案播放的時間
function seektimeupdate()
{
    // 20140331 willy build68 ---如果在備份狀態,讓功能失效---
    if(!FStaut)
    {
        return;
    }
    // 20140330 willy ------

    var debugxml = new XMLHttpRequest();
    debugxml.open("GET", url_debug+"seektimeupdate", false);
    debugxml.send();

    var now = document.getElementById("currtime");
    var all = document.getElementById("alltime");
    var nnt = videoElement.currentTime * (100 / videoElement.duration);
	trackbutton.value = nnt;
	var curmins = Math.floor(videoElement.currentTime / 60);
	var cursecs = Math.floor(videoElement.currentTime % 60);
	var durmins = Math.floor(videoElement.duration / 60);
	var dursecs = Math.floor(videoElement.duration % 60);
	if(cursecs < 10){ cursecs = "0"+cursecs; }
	if(dursecs < 10){ dursecs = "0"+dursecs; }
	if(curmins < 10){ curmins = "0"+curmins; }
	if(durmins < 10){ durmins = "0"+durmins; }
	now.innerHTML = curmins+":"+cursecs;
	all.innerHTML = durmins+":"+dursecs;
}

//9.20
//多個檔案播放的時間
function totalTime()
{/*
  // 20140331 willy build68 ---如果在備份狀態,讓功能失效---
  if(!FStaut)
  {
  return;
  }
  // 20140330 willy ------
  */
    var debugxml = new XMLHttpRequest();
    debugxml.open("GET", url_debug+"totalTime", false);
    debugxml.send();

    var now = document.getElementById("currtime");
    var all = document.getElementById("alltime");
	var nnt = current_pos_global * (100 / total_duration);
	trackbutton.value = nnt;
	var curmins = Math.floor(current_pos_global / 60);
	var cursecs = Math.floor(current_pos_global % 60);
	var durmins = Math.floor(total_duration / 60);
	var dursecs = Math.floor(total_duration % 60);
	if(cursecs < 10){ cursecs = "0"+cursecs; }
	if(dursecs < 10){ dursecs = "0"+dursecs; }
	if(curmins < 10){ curmins = "0"+curmins; }
	if(durmins < 10){ durmins = "0"+durmins; }

	all.innerHTML = durmins+":"+dursecs;

    // 20140331 OOOOO build70 ---校正結束時的顯示時間---
    if(current_pos_global <= total_duration)
        now.innerHTML = curmins+":"+cursecs;
    else
        now.innerHTML = all.innerHTML;
}
// 20140331 OOOOO build70 ---校正結束時bar的位置---
function forwardToBarEnd()
{
    var debugxml = new XMLHttpRequest();
    debugxml.open("GET", url_debug+"forwardToBarEnd", false);
    debugxml.send();
    trackbutton.style.webkitTransform = "translateX("+ tracksize +"px)";

    var now = document.getElementById("currtime");
    var all = document.getElementById("alltime");

	var durmins = Math.floor(total_duration / 60);
	var dursecs = Math.floor(total_duration % 60);

	if(dursecs < 10){ dursecs = "0"+dursecs; }
	if(durmins < 10){ durmins = "0"+durmins; }

	all.innerHTML = durmins+":"+dursecs;
    now.innerHTML = all.innerHTML;
}
// 20140331 OOOOO ------
// 20140323 林宏 build53 -----用於讓OC可以調用JS-----
function OC_Video_Create(fmsg)
{
    // Do some video length related computation and display the default video
    try
    {
        var debugxml = new XMLHttpRequest();
        debugxml.open("GET", url_debug+"OC_Video_Create:"+fmsg, false);
        debugxml.send();

        dts = 0;
        duration = defaultVideoDuration;
        compute_totaltime();

        video = document.getElementById("video_placeholder");
        subVideo = document.getElementById("subView");// 20140324 willy build56 ---小碼流物件---

        //20140402 willy build72 ---讓倒播也能順播---
        if(videobacktrack || videobackward)
        {
            video_create(fmsg, url_open_file + fmsg, ts_duration[playlist_pos]-3.8, false);
        }
        else
        {
            video_create(fmsg, url_open_file + fmsg, 0, false);
        }
        //20140402 willy ------

        //video_create(fmsg, url_open_file + fmsg, 0, false);

        // Initialize the sound volume slider
        var soundElement = document.getElementById("sound-var-range");
        soundElement.value = videoElement.volume * 100;
    }
    catch(e)
    {
        var debugxml = new XMLHttpRequest();
        debugxml.open("GET", url_debug+"OC_Video_Create_error:"+e, false);
        debugxml.send();
    }
}
//20140331 willy build68 ---隱藏聲音UI---
function OC_CopyFileBtn_Hide()
{
    try
    {
        //document.getElementById('sound').style.visibility = 'hidden';

        //var CopyFileBtn = document.getElementById("mail");
        //CopyFileBtn.style.display="none";
    }
    catch(e)
    {
        var debugxml = new XMLHttpRequest();
        debugxml.open("GET", url_debug+"OC_CopyFileBtn_Hide_Error:"+e, false);
        debugxml.send();
    }
}

function OC_CopyFileBtn_Show()
{
    try
    {
        //document.getElementById('sound').style.visibility = 'visible';
        //var CopyFileBtn = document.getElementById("mail");
        //CopyFileBtn.style.display="block";
    }
    catch(e)
    {
        var debugxml = new XMLHttpRequest();
        debugxml.open("GET", url_debug+"OC_CopyFileBtn_Hide_Error:"+e, false);
        debugxml.send();
    }
}
//20140331 willy ------
// 20140323 林宏 ----------

// 20140324 willy build56 ---改由main.js處理---
/*
 //2014.3.23 第一次播放小碼流，同function OC_Video_Create(fmsg)
 function obj_sub_create(subPath)
 {
 try
 {
 dts = 0;
 duration = defaultVideoDuration;
 compute_totaltime();

 subVideo = document.getElementById("subView");
 video_create(subPath, url_open_file + subPath, 0, false);

 var debug = new XMLHttpRequest();
 debug.open("GET", url_debug+"QQ4_subVideo_Sub:"+subPath, false);
 debug.send();

 }
 catch(e)
 {
 var debugxml = new XMLHttpRequest();
 debugxml.open("GET", url_debug+"subVideo_Create_error:"+e, false);
 debugxml.send();
 }
 }
 */

// Create the <video> tag
function video_create(src, url, time, map_reset_requested)
{
    try
    {
        // 20140320 林宏 build45 ----如果是SD格式修改成TS路徑-----
        var xmlDebug = new XMLHttpRequest();
        xmlDebug.open("GET", url_debug+"video_create1:"+src, false);
        xmlDebug.send();

        /*
         if (([fPath rangeOfString:@"/Documents/diskvideo/main"].location != NSNotFound)) {
         return;// 20140326 willy build60 ---開SD檔會回傳兩次路徑（1.備份檔案路徑 2.實體檔案路徑）---
         }
         */

        try
        {
            // 20140402 willy build72 ---設定video的起始位置---
            if(time)
            {
                deferred_seek = time;
            }

            // 20140408 willy build72 ---地圖初始化---
            xmlreq = new XMLHttpRequest();
            xmlreq.open("GET", url, false);
            xmlreq.send(null);
            parse_xml(xmlreq.responseXML);
            // 20140330 willy ------
        }
        catch(e)
        {}

        //video.style.visibility="hidden";// 20140330 willy build64 ---隱藏播放視窗---
        if(src.search(".sd") != -1)
        {
            //FStaut=true;
            // 20140320 林宏 build45 -----用於讓JS可以調用OC-----
            var fname=src.split("/");// 20140322 林宏 build48 -----開檔時用於取得檔名-----
            if(native)
            {
                var fpath=src.slice(0,src.lastIndexOf(fname[fname.length-1]))+"main"+src.split("&")[1]+".TS";
                var parameter = {'SDFilePath':src,'type':'2','SDFileName':fpath};
                //            setSubPath = fpath.replace("main","sub");

                // 20140330 willy build64 ---改由執行緒去檢查是否備份完成---
                var result = native.ocMethod(parameter);

                /*
                 var debugxml = new XMLHttpRequest();
                 debugxml.open("GET", url_debug+"video_create_Path:"+fpath, false);
                 debugxml.send();
                 */
                /*
                 while(FStaut)
                 {
                 var result = native.ocMethod(parameter);
                 if(result['message']=='true')// 判斷檔案是否備份完成
                 {
                 src=result['diskpath'];
                 //video.style.visibility="visible";// 20140330 willy build64 ---顯示播放視窗---
                 FStaut=false;
                 }
                 }
                 sleep(800);// 20140326 willy build59 ---延遲0.5s,讓html5接剛備份好的TS檔---
                 */
                // 20140330 willy ------
            }
            // 20140320 林宏 ---------
            //src=src.slice(0,src.lastIndexOf("tmpVideo.sd"))+"main"+src.split("&")[1]+".TS";
            //src=src.slice(0,src.lastIndexOf(fname[fname.length-1]))+"main"+src.split("&")[1]+".TS";
        }
        // 20140330 willy build64 ---路徑丟給html5模組化---
        else if(src.search("/Documents/diskvideo/main") != -1)
        {
            playVideo(src);

            video_play();

            // 20140331 willy build68 ---路徑丟給html5模組化---
            /*
             if(time)
             {
             deferred_seek = time;
             }*/
            if(map_reset_requested)
                reset_map();

            // 20140408 willy build72 ---地圖初始化 (刪)---
            /*
             xmlreq = new XMLHttpRequest();
             xmlreq.open("GET", url, false);
             xmlreq.send(null);
             parse_xml(xmlreq.responseXML);*/
            // 20140331 willy build68 ---路徑丟給html5模組化---
            return;// 20140327 willy build61 ---開SD檔會回傳兩次路徑（1.備份檔案路徑 2.實體檔案路徑）---
        }
        else
        {
            playVideo(src);
            /*
             if(time)
             {
             deferred_seek = time;
             }*/
            if(map_reset_requested)
                reset_map();

            // 20140408 willy build72 ---地圖初始化 (刪)---
            /*
             xmlreq = new XMLHttpRequest();
             xmlreq.open("GET", url, false);
             xmlreq.send(null);
             parse_xml(xmlreq.responseXML);*/
            // 20140330 willy ------
        }



    }
    catch(e)
    {
        var debugxml = new XMLHttpRequest();
        debugxml.open("GET", url_debug+"video_create_Error:"+e, false);
        debugxml.send();
    }

}

function video_ended()
{
    try
    {
        // 20140408 willy build72 ---預防同時呼叫兩次---
        if((new Date().getTime()-oldtime)<800)
        {
            return;
        }
        oldtime= new Date().getTime();
        // 20140408 willy ------


        var xmlreqDebug = new XMLHttpRequest();
        xmlreqDebug.open("GET", url_debug+"playlist_pos:"+playlist_pos+"ts_display_length:"+ts_display.length, false);
        xmlreqDebug.send(null);

        // 20140331 OOOOO build70 ---校正結束時bar的位置---
        try
        {
            if(playlist_pos+1 >= ts_display.length)
            {
                if(!videobacktrack)// 20140408 willy build72 ---非倒播狀態才成立---
                    forwardToBarEnd();
                    isMouseUp = false;
            }
            else
            {
                for(var i=0;i<titleIndex.length;i++)
                {
                    if(titleIndex[i]==(playlist_pos+1))
                    {
                        forwardToBarEnd();
                        break;
                    }
                    // 20140408 willy build72 ---一個目錄倒播完畢就暫停倒播---
                    else if(videobacktrack && titleIndex[i]==playlist_pos)
                    {
                        video_pause();
                        var xmlDebugd = new XMLHttpRequest();
                        xmlDebugd.open("GET", url_debug+"video_pause4", false);
                        xmlDebugd.send();

                        videobacktrack_end=true;
                        return;
                        break;
                    }
                }
            }
        }
        catch(e)
        {
            var xmlDebug = new XMLHttpRequest();
            xmlDebug.open("GET", url_debug+"forwardToBarEnd_Error:"+e, false);
            xmlDebug.send();
        }
        // 20140331 OOOOO ------

        clearHint();

        var tmpFile;        //for color setting

        if(playlist_pos < 0)
        {
            //auto-replay
            videoElement.currentTime = 0;
            //103.3.23 arthur 取消
            //replay_clearPath();

            // 20140402 willy build72 ---燈號控制(播放)---
            if(videobacktrack)
                Light_Backtrack();
            else
                Light_Play();
            // 20140402 willy ------

            return;     // Single video. Nothing more to do
        }
        // We are in a play list. Find out if we have something more to play
        var last;
        last = ts_display.length - 1; // 0 based
        /*
         var xmlreqDebug = new XMLHttpRequest();
         xmlreqDebug.open("GET", url_debug+"last:"+last+"total_duration"+total_duration+"playlist_pos"+playlist_pos, false);
         xmlreqDebug.send(null);
         */
        // 20140408 willy build72 ---非倒播狀態才成立---
        if(playlist_pos >= last && !videobacktrack)            //Last File handle
        {
            videoElement.pause();

            // 20140329 willy build63 ---燈號控制(暫停)---
            Light_Pause();

            return;  // End of list
        }
        var xmlDebug = new XMLHttpRequest();
        xmlDebug.open("GET", url_debug+"TheFileEnd:"+ts_path[playlist_pos], false);
        xmlDebug.send();

        if(videobacktrack || videolastTrack || videobackward)
        {
            --playlist_pos;
            // 20140402 willy build72 ---燈號控制(播放)---
            if(videobacktrack)
                Light_Backtrack();
            else
                Light_Play();
        }
        else
        {
            playlist_pos++;
            // 20140402 willy build72 ---燈號控制(播放)---
            Light_Play();
        }

        compute_totaltime();

        if(OpenDiskFolder==true)
        {
            tmpFile = document.getElementById(ts_display[playlist_pos]+"_disk");
            tmpFile.setAttribute('class', 'selected');
            // 20140402 willy build72 ---燈號控制(list)---
            if(videobacktrack || videolastTrack || videobackward)
            {
                videolastTrack=false;
                tmpFile = document.getElementById(ts_display[playlist_pos+1]+"_disk");
            }
            else
                tmpFile = document.getElementById(ts_display[playlist_pos-1]+"_disk");
            tmpFile.setAttribute('class', 'unselected');


        }
        else
        {
            tmpFile = document.getElementById(ts_display[playlist_pos]);
            tmpFile.setAttribute('class', 'selected');
            // 20140402 willy build72 ---燈號控制(list)---
            if(videobacktrack || videolastTrack || videobackward)
            {
                videolastTrack=false;
                tmpFile = document.getElementById(ts_display[playlist_pos+1]);
            }
            else
                tmpFile = document.getElementById(ts_display[playlist_pos-1]);
            tmpFile.setAttribute('class', 'unselected');
            folderSelect(playlist_pos, false);// 20140326 willy buid60 ---SD Card才會分目錄---
        }

        /*// 20140326 willy buid60 ---SD Card才會分目錄(刪)---
         folderSelect(playlist_pos, false);
         if(OpenDiskFolder==false)
         {
         // folderSelect(playlist_pos, false);
         }
         */

        var speedButton = document.getElementById('speed1');
        speedButton.setAttribute('class', 'selected');

        speedButton = document.getElementById('speed14');
        speedButton.setAttribute('class', 'unselected');
        speedButton = document.getElementById('speed12');
        speedButton.setAttribute('class', 'unselected');
        speedButton = document.getElementById('speed2');
        speedButton.setAttribute('class', 'unselected');
        speedButton = document.getElementById('speed4');
        speedButton.setAttribute('class', 'unselected');

        // Right, we have a new video to play
        //compute_totaltime();

        //如果是兩個section相接的兩個影片的切換需要清掉上一個section的map trace? 103.3.23 arthur 取消
        //    var mapCheck;
        //    for(mapCheck = 0; mapCheck < titleIndex.length; ++mapCheck)
        //    {
        //        if(playlist_pos == titleIndex[mapCheck])    //從頭切換
        //        {
        //            if(playlist_pos-1 >= 0 && mapCheck-1 >= 0)
        //                if(playlist_pos-1 >= titleIndex[mapCheck-1])
        //                    reset_map();
        //        }
        //    }

        // 20140402 willy build72 ---讓video倒播時也能順播---
        //video_pause();
        try
        {
            videoElement.pause();
            subVideoElement.pause();
        }
        catch(e)
        {

        }
        showLoadWeb();// 只要載入video就要有loading圖示

        if(videobacktrack || videobackward)
        {
            video_create(ts_path[playlist_pos], url_open_file+ts_path[playlist_pos], ts_duration[playlist_pos]-3.8, false);
        }
        else
        {
            var xmlDebug = new XMLHttpRequest();
            xmlDebug.open("GET", url_debug+"videoended_ts_path:"+ts_path[playlist_pos], false);
            xmlDebug.send();

            video_create(ts_path[playlist_pos], url_open_file + ts_path[playlist_pos], 0, false);
        }
        // 20140402 willy ------

    }
    catch(e)
    {
        var xmlDebug = new XMLHttpRequest();
        xmlDebug.open("GET", url_debug+"video_ended_Error:"+e, false);
        xmlDebug.send();
    }
}

function getParameterByName(name)
{
    name = name.replace("/[\[]/", "\\\[").replace("/[\]]/", "\\\]");
    var regexS = "[\\?&]" + name + "=([^&#]*)";
    var regex = new RegExp(regexS);
    var results = regex.exec(window.location.search);
    if(results == null)
        return "";
    else
        return decodeURIComponent(results[1].replace(/\+/g, " "));
}

// Compute offset_current_video
function compute_current_offset()
{
    var i;

    if(playlist_pos == -1)
    {
        offset_current_video = 0;
        return;
    }
    if(playlist_first_pos == playlist_pos)
    {
        offset_current_video = 0;
        return;
    }

    offset_current_video = parseInt(ts_duration[playlist_first_pos]);
    for(i = playlist_first_pos + 1 ; i < playlist_pos ; i++)
    {
        //if(ts_display[i][0] == '-')
        if(ts_display[i][0] == '+')
            break;
        offset_current_video += parseInt(ts_duration[i]);
    }
}

// Compute playlist_first_pos, total_duration and px_per_sec
function compute_totaltime()
{
    var i;

    if(playlist_pos == -1)
    {
        total_duration = defaultVideoDuration;
        px_per_sec = tracksize / total_duration;
        playlist_first_pos = -1;
        return;
    }
    playlist_first_pos = playlist_pos;          //???
    total_duration = parseInt(ts_duration[playlist_pos]);

    var debugxml1;

    var tmpNum, tmpUp = -1, tmpDown = -1;
    for(tmpNum = 0; tmpNum < titleIndex.length; ++tmpNum)
    {
        if(playlist_pos >= titleIndex[tmpNum])
        {
            if(tmpNum+1 < titleIndex.length)
            {
                if(playlist_pos < titleIndex[tmpNum+1])
                {
                    tmpUp = tmpNum;
                    tmpDown = tmpNum+1;
                    break;
                }
            }
            else if(tmpNum+1 == titleIndex.length)      //last section
            {
                tmpUp =tmpNum;
                tmpDown = -1;

                break;
            }
        }
    }

    if(tmpUp != -1)
    {
        playlist_first_pos = titleIndex[tmpUp];
        total_duration = 0;

        if(tmpDown != -1)
        {
            for(i = titleIndex[tmpUp] ; i < ts_display.length && i < titleIndex[tmpDown] ; i++)
            {
                total_duration += parseInt(ts_duration[i]);
            }
        }
        else
        {
            for(i = titleIndex[tmpUp] ; i < ts_display.length ; i++)
            {
                total_duration += parseInt(ts_duration[i]);
            }
        }
    }

    var debugxml = new XMLHttpRequest();
    debugxml.open("GET", url_debug+"TotalDuration"+total_duration+"WithItem"+playlist_pos, false);
    debugxml.send();

    px_per_sec = tracksize / total_duration;    // Size of the tracking bar 250

}

// Called by onload. Take care of the initialization of mostly everything
function video_init()
{
    try
    {
        // Load configuration js

        var http_port = getParameterByName("http_port");
        xmlreq = new XMLHttpRequest();
        xmlreq.open("GET", "http://localhost:"+http_port+"/conf.html", false);
        xmlreq.send(null);
        eval(xmlreq.responseText);

        lang();


        // Gyro init
        sensor_area = document.getElementById("sensor-data");
        sensor_area_ctx = sensor_area.getContext("2d");
        gyroXY = 40;
        gyroYY = 40;
        gyroZY = 40;
        gyroXX = 0;
        gyroYX = 0;
        gyroZX = 0;

        trackbutton = document.getElementById("track-var");
        // Find the X location in px of the track bar
        trackbar = document.getElementById("track");
        trackbuttonX = 0;
        if (trackbar.offsetParent)
        {
            var obj = trackbar;
            do
            {
                trackbuttonX += obj.offsetLeft;
            } while (obj = obj.offsetParent);
        }

        // Fill the file list
        var filelist = document.getElementById("filelist");
        var i, last;
        if(typeof(ts_display) == 'undefined')
        {
            // A single file has been selected
            playlist_pos = -1;
        }
        else
        {
            last = ts_display.length;
            var defaultSelect = false;
            var lastDefault = -1;
            //for(i = last-1; i >= 0 ; i--) //
            for(i = 0 ; i < last ; i++)
            {
                if(ts_path[i] == defaultVideo)
                    playlist_pos = i;

                //if(ts_display[i][0] == '-')
                if(ts_display[i][0] == '+')
                {
                    var folder = document.createElement('li');
                    folder.innerHTML = ts_display[i];
                    folder.setAttribute('id', "folder"+i);
                    folder.setAttribute('onclick', 'folderSelect('.concat(i, ", true)"));
                    filelist.appendChild(folder);

                    var fileentry = document.createElement('li');
                    var tmpIndex, tmpStr2 = "";
                    for(tmpIndex = 2; tmpIndex < ts_display[i].length; ++tmpIndex)
                    {
                        tmpStr2 = tmpStr2 + ts_display[i][tmpIndex];
                    }
                    fileentry.innerHTML = '&nbsp'+ '&nbsp'+'&nbsp'+'&nbsp'+'&nbsp'+'&nbsp'+tmpStr2;
                    fileentry.setAttribute('id', ts_display[i]);
                    fileentry.setAttribute('onclick', "fileselect("+i+"); folderSelect("+i+", false)");
                    fileentry.style.display = "none";

                    if(defaultSelect == false)
                    {
                        fileentry.setAttribute('class', 'selected');
                        folder.setAttribute('class', 'selected');
                        defaultSelect = true;
                        lastDefault = i;
                    }
                    else
                    {
                        var lastfile = document.getElementById(ts_display[lastDefault]);
                        lastfile.setAttribute('class', 'unselected');
                        lastfile = document.getElementById("folder"+lastDefault);
                        lastfile.setAttribute('class', 'unselected');
                        lastDefault = i;
                        fileentry.setAttribute('class', 'selected');
                        folder.setAttribute('class', 'selected');
                    }

                    filelist.appendChild(fileentry);

                    titleIndex[titleIndex.length] = i;
                }
                else
                {
                    var fileentry = document.createElement('li');
                    fileentry.innerHTML = '&nbsp'+ '&nbsp'+'&nbsp'+'&nbsp'+'&nbsp'+'&nbsp'+ts_display[i];
                    fileentry.setAttribute('id', ts_display[i]);
                    //fileentry.setAttribute('onclick', 'fileselect('.concat(i, ")"));
                    fileentry.setAttribute('onclick', "fileselect("+i+"); folderSelect("+i+", false)");
                    fileentry.style.display = "none";
                    filelist.appendChild(fileentry);
                }
            }

            //for(i = 0; i < ts_display.length; ++i)
            for(i = 0; i < titleIndex.length; ++i)//ts_display
            {
                indexOpen[i] = false;
            }
        }

        // 20140320 林宏 build45 -----用於讓JS可以調用OC-----
        if(defaultVideo.search("tmpVideo.sd")!=-1)
        {
            if (native)
            {
                //2014.3.23
                subVideo = document.getElementById("subView");
                //將路徑傳給OC function
                var parameter = {'SDFilePath':defaultVideo,'type':'1','SDFileName':defaultVideo};
                var result = native.ocMethod(parameter);
            }
        }
        else
        {
            // Do some video length related computation and display the default video
            dts = 0;
            duration = defaultVideoDuration;
            compute_totaltime();

            video = document.getElementById("video_placeholder");
            subVideo = document.getElementById("subView");// 20140324 willy build56 ---小碼流物件---
            video_create(defaultVideo, url_open_file + defaultVideo, 0, false);

            // Initialize the sound volume slider
            var soundElement = document.getElementById("sound-var-range");
            soundElement.value = videoElement.volume * 100;

        }
        // 20140320 林宏 -------------
    }
    catch(e)
    {
        var xmlreqDebug = new XMLHttpRequest();
        xmlreqDebug.open("GET", url_debug+"video_init_error:"+e, false);
        xmlreqDebug.send(null);

    }

}


function video_init2()
{
    var disk_file = document.getElementById("disk_file");
    disk_file.style.display="none";
    var disk_list = document.getElementById("disk_list");
    disk_list.style.display="none";

    //Global variable initialization
    //snapshot
    firstSnap = true;
    snapShot_number = 0;

    //2014.3.26
    sub_snapShot_number = 0;

    //hint message
    hint_time = 0.0;

    //video play
    current_speed = 1;
    direction = 1;
    lastEnd = false;

    //google map
    last_lon = 0.0;
    last_lat = 0.0;
    firstCarPic = false;

    //video backward play
    oneTime = false;

    //openFile
    handlePause = false;
    playFileNow = false;
    returnSD = false;
    //   returnDisk=false;
    openAgain = false;

    //initialize
    titleIndex.length=0;//重新讀取ＳＤ卡的影片數量初始化
    video_init();
    snap();     //handle截圖非全景問題
    snap_sub(); //2014.3.26
    //lang();// 20140323 willy build51 ---重整code---
}

function folderSelect(i, isFolder)
{

    var isIndex = false;
    var j;
    for(j = 0; j < titleIndex.length; j++)
    {
        if(i == titleIndex[j])
        {
            isIndex = true;
            break;
        }
    }

    if(isIndex && isFolder)
    {
        var k;

        if(j+1 == titleIndex.length)
        {
            for(k = titleIndex[j]; k < ts_display.length; ++k)
            {
                var fileentry = document.getElementById(ts_display[k]);

                if(indexOpen[j] == false)
                    fileentry.style.display = "block";
                else
                    fileentry.style.display = "none";
            }
        }
        else
        {
            for(k = titleIndex[j]; k < titleIndex[j+1]; ++k)
            {
                var fileentry = document.getElementById(ts_display[k]);

                if(indexOpen[j] == false)
                    fileentry.style.display = "block";
                else
                    fileentry.style.display = "none";

            }
        }

        if(indexOpen[j] == false)
        {
            indexOpen[j] = true;


            if(playFileNow == true)     //開啓舊檔時選單項目不亮
                return;

            var showOne = document.getElementById("folder"+i);
            showOne.setAttribute('class', 'unselected');
        }
        else
        {
            indexOpen[j] = false;

            if(playFileNow == true)     //開啓舊檔時選單項目不亮
                return;

            var showOne;
            if(j+1 == titleIndex.length)
            {
                if(playlist_pos >= titleIndex[j])
                {
                    showOne = document.getElementById("folder"+i);
                    showOne.setAttribute('class', 'selected');
                }
            }
            else if(playlist_pos >= titleIndex[j] && playlist_pos < titleIndex[j+1])
            {
                showOne = document.getElementById("folder"+i);
                showOne.setAttribute('class', 'selected');
            }
        }
    }
    var xmlreqDebug1 = new XMLHttpRequest();
    xmlreqDebug1.open("GET", url_debug+"folderSelect_1", false);
    xmlreqDebug1.send(null);

    var checkFolder;
    for(checkFolder = 0; checkFolder < titleIndex.length; ++checkFolder)
    {
        var showOne = document.getElementById("folder"+titleIndex[checkFolder]);
        if(indexOpen[checkFolder] == false)
        {
            if(checkFolder+1 == titleIndex.length)
            {
                if(playlist_pos >= titleIndex[checkFolder])
                {
                    xmlreqDebug1 = new XMLHttpRequest();
                    xmlreqDebug1.open("GET", url_debug+"folderSelect_2-1", false);
                    xmlreqDebug1.send(null);

                    showOne = document.getElementById("folder"+titleIndex[checkFolder]);
                    showOne.setAttribute('class', 'selected');
                }
                else
                {
                    showOne = document.getElementById("folder"+titleIndex[checkFolder]);
                    showOne.setAttribute('class', 'unselected');
                }
            }
            else if(playlist_pos >= titleIndex[checkFolder] && playlist_pos < titleIndex[checkFolder+1])
            {
                xmlreqDebug1 = new XMLHttpRequest();
                xmlreqDebug1.open("GET", url_debug+"folderSelect_2-2", false);
                xmlreqDebug1.send(null);

                showOne = document.getElementById("folder"+titleIndex[checkFolder]);
                showOne.setAttribute('class', 'selected');
            }
            else
            {
                showOne = document.getElementById("folder"+titleIndex[checkFolder]);
                showOne.setAttribute('class', 'unselected');
            }

        }
        else
        {
            showOne = document.getElementById("folder"+titleIndex[checkFolder]);
            showOne.setAttribute('class', 'unselected');
        }
    }
}

function fileselect(i)
{

    try
    {
        //video.style.visibility="hidden";// 20140330 willy build64 ---隱藏播放視窗---
        //103.3.23 arthur 點List 重置Map
        //        isResetMap = true;
        // 20140330 willy build64 ---顯示loading圖示---
        if(!FStaut)
        {
            return;
        }
        videobacktrack=false;// 20140408 willy build72 ---video倒播的指標---
        showLoadWeb();
        // 20140330 willy ------
        reset_map();

        var xmlreqDebug = new XMLHttpRequest();
        xmlreqDebug.open("GET", url_debug+"fileselect_1", false);
        xmlreqDebug.send(null);

        clearHint();

        var fileentry = document.getElementById(ts_display[i]);
        fileentry.setAttribute('class', 'selected');

        current_speed = 1;
        direction = 1;
        returnSD = true;

        var j;
        for(j = 0; j < ts_display.length; j++)
        {
            if(j != i)
            {
                fileentry = document.getElementById(ts_display[j]);
                fileentry.setAttribute('class', 'unselected');
            }
        }

        xmlreqDebug = new XMLHttpRequest();
        xmlreqDebug.open("GET", url_debug+"fileselect_2", false);
        xmlreqDebug.send(null);

        //folder part
        folderSelect(i, false);

        //map 103.3.23 arthur 取消
        //        replay_clearPath();

        // 20140329 willy build63 ---修正行為模式：點擊檔案一律先暫停再播放---
        //var img_loading=document.getElementById('img_loading');
        videoElement.pause();

        try
        {
            subVideoElement.pause();
        }
        catch(e)
        {
            var xmlreqDebug = new XMLHttpRequest();
            xmlreqDebug.open("GET", url_debug+"fileselect_subVideo_Error:"+e, false);
            xmlreqDebug.send(null);
        }
        // 20140329 willy build63 ---燈號控制(播放)---
        Light_Play();

        fileentry = document.getElementById('speed1');
        fileentry.setAttribute('class', 'selected');
        fileentry = document.getElementById('speed14');
        fileentry.setAttribute('class', 'unselected');
        fileentry = document.getElementById('speed12');
        fileentry.setAttribute('class', 'unselected');
        fileentry = document.getElementById('speed2');
        fileentry.setAttribute('class', 'unselected');
        fileentry = document.getElementById('speed4');
        fileentry.setAttribute('class', 'unselected');

        current_pos_global = offset_current_video + last_video_update;
        playlist_pos = i;
        playFileNow = false;
        compute_totaltime();      //點選最後一個檔案trackbutton會飛出去?
        //        clearGyro(); //103.3.27 arthur
        video_create(ts_path[i], url_open_file + ts_path[i], 0, true);
        isFileSelect = true;

        var xmlreqDebug = new XMLHttpRequest();
        xmlreqDebug.open("GET", url_debug+"fileselect_isFileSelect", false);
        xmlreqDebug.send(null);

    }
    catch(e)
    {
        var xmlreqDebug = new XMLHttpRequest();
        xmlreqDebug.open("GET", url_debug+"fileselect_Error:"+e, false);
        xmlreqDebug.send(null);
    }
}

function fileselect_disk(i)
{
    //103.3.23 arthur 點List 重置Map
    //    isResetMap = true;

    // 20140330 willy build64 ---顯示loading圖示---
    if(!FStaut)
    {
        return;
    }
    videobacktrack=false;// 20140408 willy build72 ---video倒播的指標---
    showLoadWeb();
    // 20140330 willy ------

    reset_map();

    clearHint();

    var fileentry = document.getElementById(ts_display[i]+"_disk");
    fileentry.setAttribute('class', 'selected');

    current_speed = 1;
    direction = 1;
    returnSD = true;
    //returnDisk=true;

    var xmlreqDebug = new XMLHttpRequest();
    xmlreqDebug.open("GET", url_debug+"returnDisk = true", false);
    xmlreqDebug.send(null);

    var j;
    for(j = 0; j < ts_display.length; j++)
    {
        if(j != i)
        {
            fileentry = document.getElementById(ts_display[j]+"_disk");
            fileentry.setAttribute('class', 'unselected');
        }
    }

    xmlreqDebug = new XMLHttpRequest();
    xmlreqDebug.open("GET", url_debug+"ts_display = "+ts_display[i], false);
    xmlreqDebug.send(null);
    //folder part
    // folderSelect_disk(i, false);

    xmlreqDebug = new XMLHttpRequest();
    xmlreqDebug.open("GET", url_debug+"folderSelect_disk=ok", false);
    xmlreqDebug.send(null);
    //map
    // replay_clearPath();

    // 20140329 willy build63 ---修正行為模式：點擊檔案一律先暫停再播放---
    videoElement.pause();
    try{
        subVideoElement.pause();
    }
    catch(e)
    {}
    // 20140329 willy build63 ---燈號控制(播放)---
    Light_Play();

    fileentry = document.getElementById('speed1');
    fileentry.setAttribute('class', 'selected');
    fileentry = document.getElementById('speed14');
    fileentry.setAttribute('class', 'unselected');
    fileentry = document.getElementById('speed12');
    fileentry.setAttribute('class', 'unselected');
    fileentry = document.getElementById('speed2');
    fileentry.setAttribute('class', 'unselected');
    fileentry = document.getElementById('speed4');
    fileentry.setAttribute('class', 'unselected');

    current_pos_global = offset_current_video + last_video_update;
    playlist_pos = i;
    playFileNow = false;
    compute_totaltime();      //點選最後一個檔案trackbutton會飛出去?
    //    clearGyro(); //103.3.27 arthur
    video_create(ts_path[i], url_open_file + ts_path[i], 0, true);

    //handlePause = false;

    xmlreqDebug = new XMLHttpRequest();
    xmlreqDebug.open("GET", url_debug+"disk_ts_path="+ts_path[i], false);
    xmlreqDebug.send(null);

    isFileSelect = true;

    //compute_totaltime();
}

function video_play()
{
    // 20140330 willy build64 ---如果在備份狀態,讓功能失效---
    if(!FStaut)
    {
        return;
    }
    // 20140330 willy ------

    isPlay = true;
    isPause = false;
    if(lastEnd)
    {
        videoElement.pause();
        direction = 1;
        return;
    }

    videobacktrack=false;// 20140402 willy build72 ---video倒播的指標---
    //handlePause = false;

    // 20140329 willy build63 ---燈號控制(播放)---
    Light_Play();

    direction = 1;
    video_playbackrate(1);
    videoElement.play();

    subVideoElement.currentTime = currentVideoTimeStamp;// 20140401 willy build72 ---同步雙video---

    //2014.3.23
    subVideoElement.play();


    //map 103.3.23 arthur 取消
    //    deleteOverlays();
    //    reset_map();


}

function video_pause()
{
    try
    {
        isPause = true;

        // 20140330 willy build64 ---如果在備份狀態,讓功能失效---
        if(!FStaut || isPlayVideo)
        {
            return;
        }
        // 20140330 willy ------

        clearHint();

        direction = 1;
        handlePause = true;
        //videobacktrack=false;// 20140402 willy build72 ---video倒播的指標---

        if(lastEnd)
        {
            videoElement.pause();
            try
            {
                subVideoElement.pause();// 20140402 willy build72 ---最後檔案如果有小碼流應一起暫停---
            }
            catch(e)
            {}
            return;
        }

        // 20140329 willy build63 ---燈號控制(暫停)---
        Light_Pause();

        videoElement.pause();

        //2014.3.23
        subVideoElement.pause();

        var xmlDebug = new XMLHttpRequest();
        xmlDebug.open("GET", url_debug+"video_pausezz", false);
        xmlDebug.send();

    }
    catch(e)
    {
        var xmlDebug = new XMLHttpRequest();
        xmlDebug.open("GET", url_debug+"video_pause_Error:"+e, false);
        xmlDebug.send();
    }

}

function video_playbackrate(rate)
{
    try
    {
        // 20140330 willy build64 ---如果在備份狀態,讓功能失效---
        if(!FStaut)
        {
            return;
        }
        // 20140330 willy ------


        clearHint();

        if(rate == 0.25)
        {
            playRate_25 = true;
            var speedButton = document.getElementById('speed14');
            speedButton.setAttribute('class', 'selected');

            speedButton = document.getElementById('speed12');
            speedButton.setAttribute('class', 'unselected');
            speedButton = document.getElementById('speed1');
            speedButton.setAttribute('class', 'unselected');
            speedButton = document.getElementById('speed2');
            speedButton.setAttribute('class', 'unselected');
            speedButton = document.getElementById('speed4');
            speedButton.setAttribute('class', 'unselected');
        }
        else if(rate == 0.5)
        {
            playRate_5 = true;
            var speedButton = document.getElementById('speed12');
            speedButton.setAttribute('class', 'selected');

            speedButton = document.getElementById('speed14');
            speedButton.setAttribute('class', 'unselected');
            speedButton = document.getElementById('speed1');
            speedButton.setAttribute('class', 'unselected');
            speedButton = document.getElementById('speed2');
            speedButton.setAttribute('class', 'unselected');
            speedButton = document.getElementById('speed4');
            speedButton.setAttribute('class', 'unselected');
        }
        else if(rate == 1)
        {
            playRate_1 = true;
            var speedButton = document.getElementById('speed1');
            speedButton.setAttribute('class', 'selected');

            speedButton = document.getElementById('speed14');
            speedButton.setAttribute('class', 'unselected');
            speedButton = document.getElementById('speed12');
            speedButton.setAttribute('class', 'unselected');
            speedButton = document.getElementById('speed2');
            speedButton.setAttribute('class', 'unselected');
            speedButton = document.getElementById('speed4');
            speedButton.setAttribute('class', 'unselected');

            var xmlDebug = new XMLHttpRequest();
            xmlDebug.open("GET", url_debug+"video_playbackrate_1", false);
            xmlDebug.send();
        }
        else if(rate == 2)
        {
            playRate_2 = true;
            var speedButton = document.getElementById('speed2');
            speedButton.setAttribute('class', 'selected');

            speedButton = document.getElementById('speed14');
            speedButton.setAttribute('class', 'unselected');
            speedButton = document.getElementById('speed1');
            speedButton.setAttribute('class', 'unselected');
            speedButton = document.getElementById('speed12');
            speedButton.setAttribute('class', 'unselected');
            speedButton = document.getElementById('speed4');
            speedButton.setAttribute('class', 'unselected');
        }
        else if(rate == 4)
        {
            playRate_4 = true;
            var speedButton = document.getElementById('speed4');
            speedButton.setAttribute('class', 'selected');

            speedButton = document.getElementById('speed14');
            speedButton.setAttribute('class', 'unselected');
            speedButton = document.getElementById('speed1');
            speedButton.setAttribute('class', 'unselected');
            speedButton = document.getElementById('speed2');
            speedButton.setAttribute('class', 'unselected');
            speedButton = document.getElementById('speed12');
            speedButton.setAttribute('class', 'unselected');
        }
        // 20140408 willy build72 ---video倒播的指標---
        if(videobacktrack)
            direction = -1;

        current_speed = rate;
        videoElement.playbackRate = rate * direction;

        //2014.3.23 小碼流的播放倍率
        subVideoElement.playbackRate = rate * direction;
    }
    catch(e)
    {
        var xmlDebug = new XMLHttpRequest();
        xmlDebug.open("GET", url_debug+"video_playbackrate_Error:"+e, false);
        xmlDebug.send();
    }

}

function video_backward()
{
    try
    {
        // 20140330 willy build64 ---如果在備份狀態,讓功能失效---
        if(!FStaut)
        {
            return;
        }
        // 20140330 willy ------

        clearHint();

        videobacktrack=false;
        direction = 1;

        // 20140329 willy build63 ---燈號控制(播放)---
        Light_Play();

        video_playbackrate(1);

        //map
        seek_clearPath();

        if(videoElement.currentTime >= 2)
            videoElement.currentTime -= 1.5;
        else
        {
            if(playlist_pos <= 0)       //第一個檔案或是只有一個檔案
            {
                videoElement.currentTime = 0;
                videoElement.pause();
            }
            else
            {
                videobackward=true;
                video_ended();// 20140402 willy build72 ---改由video_end控制---
                return;
            }
            // 20140402 willy build72 ---改由video_end控制(刪)---
            /*
             else
             {
             --playlist_pos;

             if(OpenDiskFolder==true)
             {
             var tmpFile = document.getElementById(ts_display[playlist_pos]+"_disk");
             tmpFile.setAttribute('class', 'selected');
             tmpFile = document.getElementById(ts_display[playlist_pos+1]+"_disk");
             tmpFile.setAttribute('class', 'unselected');

             }
             else
             {
             var tmpFile = document.getElementById(ts_display[playlist_pos]);
             tmpFile.setAttribute('class', 'selected');
             tmpFile = document.getElementById(ts_display[playlist_pos+1]);
             tmpFile.setAttribute('class', 'unselected');

             }

             //                 var tmpFile = document.getElementById(ts_display[playlist_pos]);
             //                 tmpFile.setAttribute('class', 'selected');
             //                 tmpFile = document.getElementById(ts_display[playlist_pos+1]);
             //                 tmpFile.setAttribute('class', 'unselected');

             //                 if(returnDisk == false)
             //                 {
             //                 folderSelect_disk(playlist_pos, false);
             //                 }
             //                 else
             //                 {
             //                 folderSelect(playlist_pos, false);
             //                 }
             //
             //                //folderSelect(playlist_pos, false);

             compute_totaltime();
             compute_current_offset();
             video_create(ts_path[playlist_pos], url_open_file+ts_path[playlist_pos], ts_duration[playlist_pos]-1.5, false);

             }
             */
        }
        // 20140402 willy build72 ---上面已有控制燈號的function(刪)---
        /*
         if(!videoElement.paused())
         {
         // 20140329 willy build63 ---燈號控制(播放)---
         Light_Play();
         }
         */
    }
    catch(e)
    {
        var xmlDebug = new XMLHttpRequest();
        xmlDebug.open("GET", url_debug+"video_backward_Error:"+e, false);
        xmlDebug.send();

    }
}

function video_backtrack()
{
    try
    {
        // 20140408 willy build72 ---如果在備份或倒播狀態或倒播結束,讓功能失效---
        if(!FStaut)
        {
            return;
        }

        if((!handlePause || videobacktrack_end || playlist_pos==0) && videobacktrack)
        {
            return;
        }
        // 20140408 willy ------

        clearHint();

        if(lastEnd)
            lastEnd = false;

        // 20140329 willy build63 ---燈號控制(倒播)---
        Light_Backtrack();
        videobacktrack=true;// 20140402 willy build72 ---video倒播的指標---
        direction = -1;
        video_playbackrate(1);
        videoElement.play();

        //2014.3.23
        subVideoElement.play();

        //map  103.3.23 arthur 取消
        //    deleteOverlays();
        //    reset_map();

        // 20140408 willy build72 ---清除地圖---
        reset_map();
    }
    catch(e)
    {
        var xmlDebug = new XMLHttpRequest();
        xmlDebug.open("GET", url_debug+"video_backtrack_Error:"+e, false);
        xmlDebug.send();
    }
}

function video_forward()
{
    try
    {
        // 20140330 willy build64 ---如果在備份狀態,讓功能失效---
        if(!FStaut)
        {
            return;
        }
        // 20140330 willy ------

        clearHint();

        videobacktrack=false;// 20140402 willy build72 ---video倒播的指標---
        direction = 1;
        video_playbackrate(1);

        if(playlist_pos < 0 && videoElement.currentTime+1.5 <= videoElement.duration)
            videoElement.currentTime += 1;
        else if(videoElement.currentTime+1.5 <= ts_duration[playlist_pos])
            videoElement.currentTime += 1;
        else
            video_ended();

        // 20140329 willy build63 ---燈號控制(播放)---
        Light_Play();
    }
    catch(e)
    {
        var xmlDebug = new XMLHttpRequest();
        xmlDebug.open("GET", url_debug+"video_forward_Error:"+e, false);
        xmlDebug.send();
    }
}

function video_lastTrack()
{
    try
    {
        // 20140330 willy build64 ---如果在備份狀態,讓功能失效---
        if(!FStaut)
        {
            return;
        }
        // 20140330 willy ------

        clearHint();

        if(playlist_pos <= 0)
        {
            return;
        }
        else
        {
            videobacktrack=false;// 20140408 willy build72 ---video倒播的指標---
            videolastTrack=true;
            video_ended();// 20140402 willy build72 ---改由video_end控制---
            //return;
        }

        //Need to clear trace?(否則會拉一條直線過去) 103.3.23 arthur 取消
        reset_map();

        // 20140402 willy build72 ---改由video_end控制(刪)---
        /*
         else
         {
         direction = 1;
         --playlist_pos;
         if(OpenDiskFolder==true)
         {
         var tmpFile = document.getElementById(ts_display[playlist_pos]+"_disk");
         tmpFile.setAttribute('class', 'selected');
         tmpFile = document.getElementById(ts_display[playlist_pos+1]+"_disk");
         tmpFile.setAttribute('class', 'unselected');

         }
         else
         {
         var tmpFile = document.getElementById(ts_display[playlist_pos]);
         tmpFile.setAttribute('class', 'selected');
         tmpFile = document.getElementById(ts_display[playlist_pos+1]);
         tmpFile.setAttribute('class', 'unselected');

         }

         //             if(returnDisk == false)
         //             {
         //             tmpFile = document.getElementById(ts_display[playlist_pos]+"_disk");
         //             tmpFile.setAttribute('class', 'selected');
         //             tmpFile = document.getElementById(ts_display[playlist_pos+1]+"_disk'");
         //             tmpFile.setAttribute('class', 'unselected');
         //             folderSelect_disk(playlist_pos, false);
         //             }
         //             else
         //             {
         //             tmpFile.setAttribute('class', 'selected');
         //             tmpFile = document.getElementById(ts_display[playlist_pos+1]);
         //             tmpFile.setAttribute('class', 'unselected');
         //             folderSelect(playlist_pos, false);
         //             }

         //            //folderSelect(playlist_pos, false);
         //             if(OpenDiskFolder==false)
         //             {
         //             folderSelect(playlist_pos, false);
         //             }


         // 20140329 willy build63 ---燈號控制(播放)---
         Light_Play();



         current_speed = 1;
         compute_totaltime();
         video_create(ts_path[playlist_pos], url_open_file+ts_path[playlist_pos], 0, false);
         }
         */
    }
    catch(e)
    {
        var xmlDebug = new XMLHttpRequest();
        xmlDebug.open("GET", url_debug+"video_lastTrack_Error:"+e, false);
        xmlDebug.send();
    }
}

function video_nextTrack()
{
    try
    {
        // 20140330 willy build64 ---如果在備份狀態,讓功能失效---
        if(!FStaut)
        {
            return;
        }
        // 20140330 willy ------

        if(ts_display.length==1)// 20140408 willy build72 ---如果只有一個檔案,讓功能失效---
            return;

        clearHint();

        if(playlist_pos == -1)
            return;

        direction = 1;
        videobacktrack=false;// 20140402 willy build72 ---video倒播的指標---

        current_speed = 1;
        video_ended();

        //Need to clear trace?(否則會拉一條直線過去) 103.3.23 arthur 取消
        reset_map();

    }
    catch(e)
    {
        var xmlDebug = new XMLHttpRequest();
        xmlDebug.open("GET", url_debug+"video_nextTrack_Error:"+e, false);
        xmlDebug.send();
    }
}

function video_toggleFullscreen()
{
    // 20140330 willy build64 ---如果在備份狀態,讓功能失效---
    if(!FStaut )
    {
        return;
    }
    // 20140330 willy ------

    if(isPlayVideo)
    {
        return;
    }

    if(isClickToNextFile)
    {
        return;
    }

    if(isFileSelect)
    {
        return;
    }

    if(isMouseUp)
    {
        return;
    }

    // 20140430 willy build80 ---全螢幕指標---
    hasfullmain=true;
    hasfullsub=false;
    // 20140430 willy ------

    //clearHint();

    video_Fullscreen_Size();

    isFullScreen = true;
    isRestoreScreen = false;
    var xmlreqDebug = new XMLHttpRequest();
    xmlreqDebug.open("GET", url_full_screen, false);
    xmlreqDebug.send(null);

    if(isPause && isFullScreen && isFileSelect)
    {
        videoElement.play();
    }

    if(!isPause && isFullScreen && !isMouseUp)
    {
        videoElement.play();
    }

    if(isPause && isFullScreen && !isMouseUp && !isFileSelect)
    {
        setTimeout(pauseToPlay,10);
        isFullScreen1 =true;
    }

    if(isMouseUp &&  !isPause && !isClickToNextFile)
    {
        videoElement.play();
    }

    if(isMouseUp  &&  isPause && !isClickToNextFile )
    {
        setTimeout(pauseToPlay,10);
    }

    if(isClickToNextFile  && !isPause)
    {
        videoElement.play();
    }

    if(  isPause  && isClickToNextFile )
    {
        setTimeout(pauseToPlay,10);
    }

    document.getElementById('map_canvas').style.visibility = 'hidden';
    document.getElementById('sd_frame').style.visibility = 'hidden';
    document.getElementById('disk2_frame').style.visibility = 'hidden';
    document.getElementById('fichier').style.visibility = 'hidden';
    document.getElementById('disk_frame').style.visibility = 'hidden';
    document.getElementById('speed').style.visibility = 'hidden';
    document.getElementById('data').style.visibility = 'hidden';
    document.getElementById('save').style.visibility = 'hidden';
    document.getElementById('fullscreen').style.visibility = 'hidden';
    document.getElementById('mail').style.visibility = 'hidden';
    document.getElementById('menu_bar').style.visibility = 'hidden';
    document.getElementById('grid2').style.visibility = 'hidden';
    document.getElementById("restore_icon").style.display = "block";

}

/*
 function sub_fullScreen()
 {
 try
 {
 // 20140330 willy build64 ---如果在備份狀態,讓功能失效---
 if(!FStaut)
 {
 return;
 }
 // 20140330 willy ------

 // 20140430 willy build80 ---全螢幕指標---
 hasfullmain=false;
 hasfullsub=true;
 // 20140430 willy ------

 if(document.webkitIsFullScreen)
 {
 subVideoElement.webkitCancelFullScreen();
 }
 else
 {
 var w = (subVideoElement.clientHeight * subVideoElement.videoWidth) / subVideoElement.videoHeight;
 subVideoElement.style.width = Math.ceil(w) + "px";
 subVideoElement.style.height = subVideoElement.clientHeight + "px";
 subVideoElement.webkitEnterFullScreen();
 }

 if (document.webkitCancelFullScreen)
 {
 subVideoElement.style.width = 290 + "px";
 subVideoElement.style.height = 300 + "px";
 document.webkitCancelFullScreen();
 }

 }
 catch(e)
 {
 var xmlDebug = new XMLHttpRequest();
 xmlDebug.open("GET", url_debug+"sub_fullScreen_Error="+e, false);
 xmlDebug.send();

 }

 }
 */

function app_quit()
{
    xmlreq = new XMLHttpRequest();
    xmlreq.open("GET", url_quit_app, false);
    xmlreq.send(null);
}

function volume_changed()
{
    try
    {
        // 20140330 willy build64 ---如果在備份狀態,讓功能失效---
        if(!FStaut)
        {
            return;
        }
        // 20140330 willy ------

        var soundElement = document.getElementById("sound-var-range");
        videoElement.volume = soundElement.value / 100;
        subVideoElement.volume = videoElement.volume;
    }
    catch(e)
    {}
}

// 20140430 willy build80 ---全螢幕時的音量控制---
function fullmain_volume_changed()
{
    try
    {
        // 如果在備份狀態,讓功能失效
        if(!FStaut)
            return;

        var soundElement = document.getElementById("sound-var-range");
        soundElement.value=videoElement.volume*100;
        subVideoElement.volume = videoElement.volume;
    }
    catch(e)
    {}
}

function fullsub_volume_changed()
{
    try
    {
        // 如果在備份狀態,讓功能失效
        if(!FStaut)
            return;

        var soundElement = document.getElementById("sound-var-range");
        soundElement.value=subVideoElement.volume*100;
        videoElement.volume = subVideoElement.volume;
    }
    catch(e)
    {}
}
// 20140430 willy ------

function video_position_outside_current_track(target_timestamp)
{
    if(target_timestamp < 0)
        target_timestamp = 0;

    if(playlist_pos == -1)
    {
        return;
    }

    // Find the new track id
    var i, start_of_track = 0, end_of_track = 0;

    for(i = playlist_first_pos ; i < ts_display.length ; i++)
    {
        end_of_track += parseInt(ts_duration[i]);
        if(target_timestamp < end_of_track)
            break;  // Found it
        start_of_track = end_of_track;
    }
    playlist_pos = i;


    // Compute the offset and load the video
    compute_totaltime();
    video_create(ts_path[playlist_pos], url_open_file + ts_path[playlist_pos], target_timestamp - start_of_track, true);

    if(OpenDiskFolder==true)
    {
        var fileentry = document.getElementById(ts_display[playlist_pos]+"_disk");
        fileentry.setAttribute('class', 'selected');

        var j;
        for(j = 0; j < ts_display.length; j++)
        {
            if(j != playlist_pos)
            {
                fileentry = document.getElementById(ts_display[j]+"_disk");
                fileentry.setAttribute('class', 'unselected');

            }
        }
    }
    else
    {
        var fileentry = document.getElementById(ts_display[playlist_pos]);
        fileentry.setAttribute('class', 'selected');

        var j;
        for(j = 0; j < ts_display.length; j++)
        {
            if(j != playlist_pos)
            {
                fileentry = document.getElementById(ts_display[j]);
                fileentry.setAttribute('class', 'unselected');

            }
        }
    }
    /*
     var fileentry = document.getElementById(ts_display[playlist_pos]);
     fileentry.setAttribute('class', 'selected');

     var j;
     for(j = 0; j < ts_display.length; j++)
     {
     if(j != playlist_pos)
     {
     fileentry = document.getElementById(ts_display[j]);
     fileentry.setAttribute('class', 'unselected');

     }
     }
     */
}

function track_mouse_down()
{
    try
    {
        // 20140330 willy build64 ---如果在備份狀態,讓功能失效---
        if(!FStaut)
        {
            return;
        }
        // 20140330 willy ------


        isMouseDown = true;

        var xmlDebug = new XMLHttpRequest();
        xmlDebug.open("GET", url_debug+"track_mouse_down", false);
        xmlDebug.send();

        // 20140331 willy build69 ---移動bar先暫停並顯示loading圖示---
        //video_pause();
        videoElement.pause();
        subVideoElement.pause();
        showLoadWeb();
        reset_map();// 不會進去seek_video
        // 20140331 willy ------

        //        clearHint();



        var offX = 0;
        isTrackButtonMoving = 1;
        document.onmouseup = function()
        {
            var xmlDebug = new XMLHttpRequest();
            xmlDebug.open("GET", url_debug+"track_mouse_up", false);
            xmlDebug.send();

            isMouseUp = true;
            isMouseDown = false;
            // Drag finished. Remove the onmousemove event immediately
            document.onmousemove = null;
            isTrackButtonMoving = 0;
            // Compute the the new time position

            if(offX >= tracksize - 1)
            {
                offX = tracksize - 1.2;
            }

            var tmp = offX / px_per_sec;

            // Figure out if we're still inside the same track
            if(tmp < offset_current_video)
            {
                // Before the current track
                video_position_outside_current_track(tmp);
                document.onmouseup = null;

                //2014.4.21
                trackbutton.style.webkitTransform = "translateX("+offX+"px)";

                if(offX < 0)
                {
                    trackbutton.style.webkitTransform = "translateX("+0+"px)";
                }
                return;
            }
            if(playlist_pos != -1)
            {

                if(tmp > offset_current_video + parseInt(ts_duration[playlist_pos]))
                {
                    isClickToNextFile = true;
                    // After the current track
                    video_position_outside_current_track(tmp);
                    document.onmouseup = null;

                    //2014.4.21
                    trackbutton.style.webkitTransform = "translateX("+offX+"px)";

                    if(offX > tracksize)
                    {
                        trackbutton.style.webkitTransform = "translateX("+tracksize+"px)";
                    }
                    return;
                }
            }
            // Still inside the same track

            seek_video(videoElement, tmp - offset_current_video);

            // 20140401 willy build72 ---seek_sub_video由主碼流直接控制即可---
            //2014.3.23
            //seek_sub_video(subVideoElement, tmp - offset_current_video);

            document.onmouseup = null;

            //handle button color
            if(direction == 1)
            {
                // 20140329 willy build63 ---燈號控制(播放)---
                Light_Play();
            }
            else if(direction == -1)
            {
                // 20140329 willy build63 ---燈號控制(倒播)---
                Light_Backtrack();
            }

            window.scrollTo(0,0);

        }
        document.onmousemove = function(e)
        {

            offX = e.clientX - trackbuttonX - 20; // Take the middle of the sprite

            if((offX > 0) && (offX < tracksize-2))
            {
                trackbutton.style.webkitTransform = "translateX("+offX+"px)";
            }

            if(isFullScreen)
            {
                if(screenW >1600)
                {
                    if(getMainView)
                    {
                        offX = e.clientX - trackbuttonX -230; // Take the middle of the sprite

                        if((offX > 0) && (offX < tracksize-2))
                        {
                            trackbutton.style.webkitTransform = "translateX("+offX+"px)";
                        }
                    }
                    else if(createSubView)
                    {
                        offX = e.clientX - trackbuttonX -190; // Take the middle of the sprite

                        if((offX > 0) && (offX < tracksize-2))
                        {
                            trackbutton.style.webkitTransform = "translateX("+offX+"px)";
                        }

                        var xmlDebug = new XMLHttpRequest();
                        xmlDebug.open("GET", url_debug+"track_mouse_60", false);
                        xmlDebug.send();

                    }
                    else if(typeEO5 == "1")
                    {
                        offX = e.clientX - trackbuttonX -230; // Take the middle of the sprite

                        if((offX > 0) && (offX < tracksize-2))
                        {
                            trackbutton.style.webkitTransform = "translateX("+offX+"px)";
                        }
                    }
                }
                else if(screenW < 1600)
                {
                    if(getMainView)
                    {
                        offX = e.clientX - trackbuttonX +40; // Take the middle of the sprite

                        if((offX > 0) && (offX < tracksize-2))
                        {
                            trackbutton.style.webkitTransform = "translateX("+offX+"px)";
                        }
                    }else if(createSubView)
                    {
                        offX = e.clientX - trackbuttonX +195; // Take the middle of the sprite

                        if((offX > 0) && (offX < tracksize-2))
                        {
                            trackbutton.style.webkitTransform = "translateX("+offX+"px)";
                        }

                    }
                    else if(typeEO5 == "1")
                    {
                        offX = e.clientX - trackbuttonX +40; // Take the middle of the sprite

                        if((offX > 0) && (offX < tracksize-2))
                        {
                            trackbutton.style.webkitTransform = "translateX("+offX+"px)";
                        }
                    }

                }
            }

        }

    }
    catch(e)
    {
        var xmlDebug = new XMLHttpRequest();
        xmlDebug.open("GET", url_debug+"track_mouse_down_Error="+e, false);
        xmlDebug.send();
    }

}

function snap()
{
    try
    {
        isFullScreen = false;
        isRestoreScreen = false;

        // 20140330 willy build67 ---截圖有問題,先不擋---
        /*
         // 20140330 willy build64 ---如果在備份狀態,讓功能失效---
         if(!FStaut)
         {
         return;
         }
         // 20140330 willy ------
         */
        snapShot_number = snapShot_number + 1;

        //2014.3.26


        if(playlist_pos < 0 && firstSnap == true)
        {
            videoElement.setAttribute('src', defaultVideo);

            firstSnap = false;
        }
        //        else if(firstSnap == true)
        //        {
        //            firstSnap = false;
        //
        //            videoElement.setAttribute('src', ts_path[playlist_pos]);
        //        }

        canvas = document.getElementById("snapshot");
        context = canvas.getContext('2d');

        // Define the size of the rectangle that will be filled (basically the entire element)
        //context.fillRect(0, 0, w, h);
        // Grab the image from the video
        //context.drawImage(videoElement, 0, 0, w, h);

        canvas.width = 1180; //videoElement.clientWidth;
        canvas.height = 663; //videoElement.clientHeight;

        context.fillRect(0, 0, canvas.width, canvas.height);
        context.drawImage(videoElement, 0, 0, canvas.width, canvas.height);

        var dataURL = canvas.toDataURL("image/jpeg");       //jpeg檔案長度較小

        //存到local端
        if(snapShot_number > 1)
        {
            var picSize = dataURL.length;
            var i, buffer = 8000;

            for(i = 0; i*buffer < picSize; ++i)
            {
                var tmpSubPic = dataURL.substr(i*buffer, buffer);

                xmlreq = new XMLHttpRequest();
                xmlreq.open("GET", url_save_pic+tmpSubPic, false);
                xmlreq.send(null);
            }

            xmlreq = new XMLHttpRequest();
            xmlreq.open("GET", url_save_pic+"end", false);
            xmlreq.send(null);

            var xmlpath = new XMLHttpRequest();
            xmlpath.open("GET", url_shot_path+"shot_path", false);
            xmlpath.send(null);

        }

        //2014.3.26
        if(createSubView)
        {
            snap_sub();
        }

    }
    catch(e)
    {
        var xmlDebug = new XMLHttpRequest();
        xmlDebug.open("GET", url_debug+"Snap_Error:"+e, false);
        xmlDebug.send();
    }
}

function snap_sub()
{
    sub_snapShot_number = sub_snapShot_number + 1;

    if(setSubPath < 0 && sub_firstSnap == true)
    {
        subVideoElement.setAttribute('src', setSubPath);

        sub_firstSnap = false;
    }
    else if(sub_firstSnap == true)
    {
        sub_firstSnap = false;

        subVideoElement.setAttribute('src', setSubPath);
    }

    sub_canvas = document.getElementById("snapSub");
    sub_context = sub_canvas.getContext('2d');

    //    sub_context.fillRect(0, 0, sub_w, sub_h);
    //    sub_context.drawImage(subVideoElement, 0, 0, sub_w, sub_h);

    sub_canvas.width = 540; //videoElement.clientWidth;
    sub_canvas.height = 405; //videoElement.clientHeight;

    sub_context.fillRect(0, 0, sub_canvas.width, sub_canvas.height);
    sub_context.drawImage(subVideoElement, 0, 0, sub_canvas.width, sub_canvas.height);


    var dataURL = sub_canvas.toDataURL("image/jpeg");       //jpeg檔案長度較小

    //存到local端
    if(sub_snapShot_number > 1)
    {
        var picSize = dataURL.length;
        var i, buffer = 8000;

        for(i = 0; i*buffer < picSize; ++i)
        {
            var tmpSubPic = dataURL.substr(i*buffer, buffer);

            var save = new XMLHttpRequest();
            save.open("GET", url_save_sub+tmpSubPic, false);
            save.send(null);

        }

        var save1 = new XMLHttpRequest();
        save1.open("GET", url_save_sub+"end", false);
        save1.send(null);

    }

}


function clearHint()
{
    // 20140327 willy build61 ---暫不使用---
    /*
     var hint = document.getElementById("hint_message");
     hint.style.display = "none";
     hint_time = 0;
     */
}

function openFile()
{

    try
    {
        // 20140330 willy build64 ---如果在備份狀態,讓功能失效---
        if(!FStaut)
        {
            return;
        }
        // 20140330 willy ------

        // 20140323 willy build51 ---重整code(doCancel)---
        //if(typeof(doCancel) != 'undefined')         //處理open file後點選cancel之後影片無法pause的問題
        if(doCancel==false)
            openAgain = true;

        var http_port = getParameterByName("http_port");
        var xmlreqOpen = new XMLHttpRequest();
        xmlreqOpen.open("GET", "http://localhost:"+http_port+"/take.html", false);
        xmlreqOpen.send(null);
        eval(xmlreqOpen.responseText);

        video_pause();// 20140323 willy build51 ---開檔時讓video暫停---
        var xmlDebugw = new XMLHttpRequest();
        xmlDebugw.open("GET", url_debug+"video_pause1", false);
        xmlDebugw.send();
    }
    catch(e)
    {
        var xmlDebug = new XMLHttpRequest();
        xmlDebug.open("GET", url_debug+"OpenFile_Error="+e, false);
        xmlDebug.send();
    }
}

function handleOpening()
{
    try
    {
        // 20140323 willy build51 ---重新取得list---
        if(OpenDiskFolder)
        {
            var http_port = getParameterByName("http_port");
            var xmlreqOpen = new XMLHttpRequest();
            xmlreqOpen.open("GET", "http://localhost:"+http_port+"/take_Disk.html", false);
            xmlreqOpen.send(null);
            eval(xmlreqOpen.responseText);

            isOpenFile = true;

            var xmlDebug = new XMLHttpRequest();
            xmlDebug.open("GET", url_debug+"OpenDiskFolderoo:"+isOpenFile, false);
            xmlDebug.send();
        }
        else
        {
            var http_port = getParameterByName("http_port");
            var xmlreqOpen = new XMLHttpRequest();
            xmlreqOpen.open("GET", "http://localhost:"+http_port+"/take_Card.html", false);
            xmlreqOpen.send(null);
            eval(xmlreqOpen.responseText);

            var xmlDebug = new XMLHttpRequest();
            xmlDebug.open("GET", url_debug+"OpenDiskFolderxx", false);
            xmlDebug.send();

        }
        // 20140323 willy ------

        //處理開檔後不能pause的問題(open file後cancel)
        if(handlePause == true && playFileNow == true)      //播放開啓的檔案時
            return;
        else if(handlePause == true && returnSD == true)                          //又去點選檔案列表的檔案項目
            return;


        if(doCancel == true)
        {
            return;
        }

        if(Btn_Open==false)//if(haveChoose == false)         //no file need to load
        {
            return;
        }

        playFileNow = true;

        if(playlist_pos != -1 && returnSD==true && OpenDiskFolder==false)      //有讀到SD card時才需要做的處理////////////
        {
            //SD card file顏色移除
            var fileentry = document.getElementById(ts_display[playlist_pos]);
            fileentry.setAttribute('class', 'unselected');
            //SD card folder顏色移除
            var abb;
            for(abb = 0; abb < titleIndex.length; ++abb)
            {
                fileentry = document.getElementById("folder"+titleIndex[abb]);
                fileentry.setAttribute('class', 'unselected');
            }
        }

        // 20140327 willy build63 ---讀sd檔時,video不會順播---
        if(ts_display.length<=1)
        {
            playlist_pos = 0;      //視為開啓舊檔的單一檔案
        }
        // 20140327 willy ------

        Btn_Open=false;// 20140323 willy build51 ---避免開檔時檔案一直reload---

    }
    catch(e)
    {
        var xmlreqDebug = new XMLHttpRequest();
        xmlreqDebug.open("GET", url_debug+"handleOpening_Error: "+e, false);
        xmlreqDebug.send(null);

    }
}

//information顯示版本資訊
function version()
{
    var xmlreqSet = new XMLHttpRequest();
    xmlreqSet.open("GET", url_setting, false);
    xmlreqSet.send(null);

}

function lang()
{
    xLanguage = getParameterByName("lang");
    typeEO5 = getParameterByName("dcim");
    osxVer = getParameterByName("osx");

    if(osxVer.indexOf('10.9')!=-1)
    {
        osx10_9 = true;
    }

    if (xLanguage == "fr")
    {
        var sd_card = document.getElementById("sd_card");
        sd_card.innerHTML = fr_filelist;

        var gpsSpeed = document.getElementById("GPSspeed");
        gpsSpeed.innerHTML = fr_speed;

        var xx = document.getElementById("x");
        xx.innerHTML = fr_x;

        var yy = document.getElementById("y");
        yy.innerHTML = fr_y;

        var zz = document.getElementById("z");
        zz.innerHTML = fr_z;
        // 20140603 willy build89 ---解決語系選擇法文時,會一直loading的問題---
        /*
         var hintMsg = document.getElementById("hint_content");
         hintMsg.innerHTML = fr_hintMsg;
         */
        var sd = document.getElementById("sdString");
        sd.innerHTML = fr_sdCard;

        var disk = document.getElementById("diskString");
        disk.innerHTML = fr_open;

        var opendisk = document.getElementById("openfileString");
        opendisk.innerHTML = fr_openfolder;

        var disk_file = document.getElementById("disk_file");
        disk_file.innerHTML = fr_diskList;

        // 20140330 willy build65 ---loading訊息---
        document.getElementById("loading_msg").innerHTML = "Chargement...";
    }
    else
    {
        var sd_card = document.getElementById("sd_card");
        sd_card.innerHTML = en_filelist;

        var gpsSpeed = document.getElementById("GPSspeed");
        gpsSpeed.innerHTML = en_speed;

        var xx = document.getElementById("x");
        xx.innerHTML = en_x;

        var yy = document.getElementById("y");
        yy.innerHTML = en_y;

        var zz = document.getElementById("z");
        zz.innerHTML = en_z;

        var sd = document.getElementById("sdString");
        sd.innerHTML = en_sdCard;

        var disk = document.getElementById("diskString");
        disk.innerHTML = en_open;

        var opendisk = document.getElementById("openfileString");
        opendisk.innerHTML = en_openfolder;

        var disk_file = document.getElementById("disk_file");
        disk_file.innerHTML = en_diskList;

        // 20140330 willy build65 ---loading訊息---
        document.getElementById("loading_msg").innerHTML = "Loading...";
    }
}
// 20140323 willy build51 ---重整code---


function copyfile()
{
    // 20140330 willy build64 ---如果在備份狀態,讓功能失效---
    if(!FStaut)
    {
        return;
    }
    // 20140330 willy ------

    isFullScreen = false;
    isRestoreScreen = false;

    var xmlreqSet = new XMLHttpRequest();
    xmlreqSet.open("GET", url_copyfile, false);
    xmlreqSet.send(null);

    var xSet = new XMLHttpRequest();
    xSet.open("GET", url_dirPath+"654", false);
    xSet.send(null);


}

function settings()
{
    var xmlreqSet = new XMLHttpRequest();
    xmlreqSet.open("GET", url_settings, false);
    xmlreqSet.send(null);

}

//20140323 林宏 build51 -----通知JS是否有執行開檔-----
function OC_OpenFile_Status(open_status)
{
    try
    {

        Btn_Open = open_status;//取代haveChoose用
        returnSD = open_status;// 20140323 willy build51 ---開檔指標---
        var xmlDebug = new XMLHttpRequest();
        xmlDebug.open("GET", url_debug+"openstatus:"+Btn_Open, false);
        xmlDebug.send();

        if(open_status =="true")
        {
            OpenFileStatus = open_status;// 20140323 willy build51 ---第一次開檔後永遠為true---
            doCancel = false;
            video_pause();// 20140331 willy build69 ---開SD檔時先暫停---
            var xmlDebugq = new XMLHttpRequest();
            xmlDebugq.open("GET", url_debug+"video_pause2", false);
            xmlDebugq.send();

            // 20140401 willy build71 ---開SD檔出現loading圖示---
            if(!firstopen)
            {
                showLoadWeb();
            }
            // 20140401 willy ------
            Btn_DiskList();// 20140323 willy build51 ---控制切換列表---
            reset_map();// 20140323 willy build51 ---改由開檔控制---
        }
        else
        {
            doCancel = true;
            video_play();// 20140330 willy build66 ---沒有選檔必須直接播放---
        }
    }
    catch(e)
    {
        var xmlDebug = new XMLHttpRequest();
        xmlDebug.open("GET", url_debug+"OC_OpenFile_Status_Error:"+e, false);
        xmlDebug.send();
    }
}
//20140323 林宏 ----------

// 20140323 willy build51 ---重整code---
function Btn_DiskList()//控制Disk按鈕
{
    try
    {
        isBtnDiskList = true;
        //未開檔讓功能失效
        if(!OpenFileStatus)
        {
            var xmlDebug = new XMLHttpRequest();
            xmlDebug.open("GET", url_debug+"openstatus:"+OpenFileStatus, false);
            xmlDebug.send();
            return;
        }

        // 20140330 willy build64 ---先暫停,等開始播放後再開始---
        video_pause();
        var xmlDebugs = new XMLHttpRequest();
        xmlDebugs.open("GET", url_debug+"video_pause3", false);
        xmlDebugs.send();

        // 20140401 willy build71 ---判斷是否第一次進來---
        if(!firstopen)
        {
            showLoadWeb();
        }
        else
        {
            firstopen=false;
            isPause = false; //0617
        }
        // 20140401 willy ------
        // 20140326 willy build60 ---取得DsikList資訊(移來前面)---
        var http_port = getParameterByName("http_port");
        xmlreqOpen = new XMLHttpRequest();
        xmlreqOpen.open("GET", "http://localhost:"+http_port+"/take_Disk.html", false);
        xmlreqOpen.send(null);
        eval(xmlreqOpen.responseText);

        //控制切換列表的顯示按鈕
        var disk_file = document.getElementById("disk_file");
        disk_file.style.display="block";
        var disk_list = document.getElementById("disk_list");
        disk_list.style.display="block";

        var sd_card = document.getElementById("sd_card");
        sd_card.style.display="none";
        var sdfilelist = document.getElementById("filelist");
        sdfilelist.style.display="none";

        var tmpButton = document.getElementById('disk2_frame');
        tmpButton.setAttribute('class', 'selected');
        tmpButton = document.getElementById('sd_frame');
        tmpButton.setAttribute('class', 'unselected');

        //重新讀取List
        disk_list.innerHTML = "";
        reload_DiskList();

        // 20140408 willy build72 ---燈號控制(播放)---
        Light_Play();

        //開檔指標
        OpenDiskFolder=true;

        // 20140408 willy build72 ---video倒播的指標---
        videobacktrack=false;
        direction = 1;
        video_playbackrate(1);

        //重新設定map
        reset_map();

        //        var current = document.getElementById("currtime");
        //        current.innerHTML = "00"+":"+"00";
        //        var xmlDebug = new XMLHttpRequest();
        //        xmlDebug.open("GET", url_debug+"Btn_DiskList_current:"+current, false);
        //        xmlDebug.send();
    }
    catch(e)
    {
        var xmlDebug = new XMLHttpRequest();
        xmlDebug.open("GET", url_debug+"Btn_DiskList_Error:"+e, false);
        xmlDebug.send();
    }

}

function Btn_CardList()//控制Card按鈕
{
    try
    {
        // 20140330 willy build64 ---如果在備份狀態,讓功能失效---
        if(!FStaut)
        {
            return;
        }
        // 20140330 willy ------

        if(openFile_loseUSB == "1")
        {
            return;
        }

        isBtnCardList = true;
        isOpenFile = false;

        // 20140326 willy build60 ---取得CardList資訊(移來前面)---
        var http_port = getParameterByName("http_port");
        xmlreqOpen = new XMLHttpRequest();
        xmlreqOpen.open("GET", "http://localhost:"+http_port+"/take_Card.html", false);
        xmlreqOpen.send(null);
        eval(xmlreqOpen.responseText);

        var xmlDebug = new XMLHttpRequest();
        xmlDebug.open("GET", url_debug+"Btn_CardList:"+defaultVideoDuration, false);
        xmlDebug.send();

        // 20140326 willy build60 ---判斷是否有插卡---
        if(defaultVideoDuration == 100000)
        {
            //取得DsikList資訊
            xmlreqOpen = new XMLHttpRequest();
            xmlreqOpen.open("GET", "http://localhost:"+http_port+"/take_Disk.html", false);
            xmlreqOpen.send(null);
            eval(xmlreqOpen.responseText);
            return;
        }
        // 20140326 willy ------

        //控制切換列表的顯示按鈕
        var disk_file = document.getElementById("disk_file");
        disk_file.style.display="none";
        var disk_list = document.getElementById("disk_list");
        disk_list.style.display="none";

        var sd_card = document.getElementById("sd_card");
        sd_card.style.display="block";
        var card_list = document.getElementById("filelist");
        card_list.style.display="block";

        var tmpButton = document.getElementById('disk2_frame');
        tmpButton.setAttribute('class', 'unselected');
        tmpButton = document.getElementById('sd_frame');
        tmpButton.setAttribute('class', 'selected');

        //重新讀取List
        card_list.innerHTML = "";
        reload_CardList();

        // 20140408 willy build72 ---燈號控制(播放)---
        Light_Play();

        //開檔指標
        OpenDiskFolder=false;

        // 20140408 willy build72 ---video倒播的指標---
        videobacktrack=false;
        direction = 1;
        video_playbackrate(1);

        //重新設定map
        reset_map();
    }
    catch(e)
    {
        var xmlDebug = new XMLHttpRequest();
        xmlDebug.open("GET", url_debug+"Btn_CardList_Error:"+e, false);
        xmlDebug.send();
    }

}

function reload_DiskList()//重新整理Disklist
{
    var xmlDebug = new XMLHttpRequest();
    xmlDebug.open("GET", url_debug+"reload_DiskList", false);
    xmlDebug.send();

    // 建立Disk List
    try
    {
        titleIndex.length=0;//20140401 willy build71 ---重新讀取DiskList的影片數量初始化---
        var disklist = document.getElementById("disk_list");
        var i, last;

        disklist.innerHTML="";

        last = ts_display.length;
        var defaultSelect = false;
        var lastDefault = -1;
        if(last==152)
        {

            var xmlDebug = new XMLHttpRequest();
            xmlDebug.open("GET", url_debug+"openfile_onlyone", false);
            xmlDebug.send();

            var fileentry = document.createElement('li');
            fileentry.setAttribute('id', "file_disk");
            fileentry.setAttribute('onclick', "fileselect_disk("+i+")");
            fileentry.setAttribute('class', 'selected');
            disklist.appendChild(fileentry);

        }
        else
        {
            var xmlDebug = new XMLHttpRequest();
            xmlDebug.open("GET", url_debug+"openfile_fodler:", false);
            xmlDebug.send();

            for(i = 0 ; i < last; i++)
            {
                if(ts_path[i] == defaultVideo)
                    playlist_pos = i;

                if(ts_display[i][0] == '+')
                {
                    var fileentry = document.createElement('li');
                    var tmpIndex, tmpStr2 = "";
                    for(tmpIndex = 2; tmpIndex < ts_display[i].length; ++tmpIndex)
                    {
                        tmpStr2 = tmpStr2 + ts_display[i][tmpIndex];
                    }
                    fileentry.innerHTML = '&nbsp'+ '&nbsp'+'&nbsp'+'&nbsp'+'&nbsp'+'&nbsp'+tmpStr2;
                    fileentry.setAttribute('id', ts_display[i]+"_disk");
                    fileentry.setAttribute('onclick', "fileselect_disk("+i+")");
                    if(i==0)// 20140328 willy build63 ---開檔時,list會亮兩個燈號---
                    {
                        fileentry.setAttribute('class', 'selected');
                    }
                    disklist.appendChild(fileentry);

                    titleIndex[titleIndex.length] = i;

                }
                else
                {
                    var fileentry = document.createElement('li');
                    fileentry.innerHTML = '&nbsp'+ '&nbsp'+'&nbsp'+'&nbsp'+'&nbsp'+'&nbsp'+ts_display[i];
                    fileentry.setAttribute('id', ts_display[i]+"_disk");
                    fileentry.setAttribute('onclick', "fileselect_disk("+i+")");
                    disklist.appendChild(fileentry);
                    titleIndex[titleIndex.length] = i;// 20140328 willy build63 ---讓seek bar以一個檔案為單位---
                }

            }

            //titleIndex[titleIndex.length] = ts_display.length-1;

            for(i = 0; i < ts_display.length; ++i)
            {
                indexOpen[i] = false;
            }

            xmlDebug = new XMLHttpRequest();
            xmlDebug.open("GET", url_debug+"openfile_fodler_finish", false);
            xmlDebug.send();
        }
    }
    catch(e)
    {
        var xmlreqDebug = new XMLHttpRequest();
        xmlreqDebug.open("GET", url_debug+"reload_Disklist_Error"+e, false);
        xmlreqDebug.send(null);
    }

    // 準備播放video
    try
    {
        dts = 0;
        duration = defaultVideoDuration;
        compute_totaltime();

        video = document.getElementById("video_placeholder");
        subVideo = document.getElementById("subView");// 20140324 willy build56 ---小碼流物件---
        video_create(defaultVideo, url_open_file + defaultVideo, 0, false);

        // Initialize the sound volume slider
        var soundElement = document.getElementById("sound-var-range");
        soundElement.value = videoElement.volume * 100;

        //map
        //replay_clearPath();

        xmlDebug = new XMLHttpRequest();
        xmlDebug.open("GET", url_debug+"DiskListshow_ok:", false);
        xmlDebug.send();
    }
    catch(e)
    {
        xmlDebug = new XMLHttpRequest();
        xmlDebug.open("GET", url_debug+"DiskListshow_Error:"+e, false);
        xmlDebug.send();
    }

}

function reload_CardList()//重新整理Cardlist
{
    var xmlDebug = new XMLHttpRequest();
    xmlDebug.open("GET", url_debug+"reload_CardList", false);
    xmlDebug.send();

    try
    {
        titleIndex.length=0;// 重新讀取CardList的影片數量初始化
        // Fill the file list
        var filelist = document.getElementById("filelist");
        var i, last;
        if(typeof(ts_display) == 'undefined')
        {
            // A single file has been selected
            playlist_pos = -1;
        }
        else
        {
            last = ts_display.length;
            var defaultSelect = false;
            var lastDefault = -1;

            for(i = 0 ; i < last ; i++)
            {
                if(ts_path[i] == defaultVideo)
                    playlist_pos = i;

                if(ts_display[i][0] == '+')
                {
                    var folder = document.createElement('li');
                    folder.innerHTML = ts_display[i];
                    folder.setAttribute('id', "folder"+i);
                    folder.setAttribute('onclick', 'folderSelect('.concat(i, ", true)"));
                    filelist.appendChild(folder);

                    var fileentry = document.createElement('li');
                    var tmpIndex, tmpStr2 = "";
                    for(tmpIndex = 2; tmpIndex < ts_display[i].length; ++tmpIndex)
                    {
                        tmpStr2 = tmpStr2 + ts_display[i][tmpIndex];
                    }
                    fileentry.innerHTML = '&nbsp'+ '&nbsp'+'&nbsp'+'&nbsp'+'&nbsp'+'&nbsp'+tmpStr2;
                    fileentry.setAttribute('id', ts_display[i]);
                    fileentry.setAttribute('onclick', "fileselect("+i+"); folderSelect("+i+", false)");
                    fileentry.style.display = "none";

                    if(defaultSelect == false)
                    {
                        fileentry.setAttribute('class', 'selected');
                        folder.setAttribute('class', 'selected');
                        defaultSelect = true;
                        lastDefault = i;
                    }
                    else
                    {
                        var lastfile = document.getElementById(ts_display[lastDefault]);
                        lastfile.setAttribute('class', 'unselected');
                        lastfile = document.getElementById("folder"+lastDefault);
                        lastfile.setAttribute('class', 'unselected');
                        lastDefault = i;
                        fileentry.setAttribute('class', 'selected');
                        folder.setAttribute('class', 'selected');
                    }

                    filelist.appendChild(fileentry);

                    titleIndex[titleIndex.length] = i;

                    defaultVideo=ts_path[i];
                }
                else
                {
                    var fileentry = document.createElement('li');
                    fileentry.innerHTML = '&nbsp'+ '&nbsp'+'&nbsp'+'&nbsp'+'&nbsp'+'&nbsp'+ts_display[i];
                    fileentry.setAttribute('id', ts_display[i]);
                    fileentry.setAttribute('onclick', "fileselect("+i+"); folderSelect("+i+", false)");
                    fileentry.style.display = "none";
                    filelist.appendChild(fileentry);
                }
            }

            for(i = 0; i < titleIndex.length; ++i)//ts_display
            {
                indexOpen[i] = false;
            }
        }

    }
    catch(e)
    {
        var xmlreqDebug = new XMLHttpRequest();
        xmlreqDebug.open("GET", url_debug+"reload_CardList_Error:"+e, false);
        xmlreqDebug.send(null);
    }

    // 準備播放video
    try
    {
        dts = 0;
        duration = defaultVideoDuration;
        playlist_pos = lastDefault;// 20140327 willy build61 ---糾正切換SD Card時,video的結束時間---
        compute_totaltime();

        video = document.getElementById("video_placeholder");
        subVideo = document.getElementById("subView");// 20140324 willy build56 ---小碼流物件---
        video_create(defaultVideo, url_open_file + defaultVideo, 0, false);

        // Initialize the sound volume slider
        var soundElement = document.getElementById("sound-var-range");
        soundElement.value = videoElement.volume * 100;

        //map
        //replay_clearPath();

        xmlDebug = new XMLHttpRequest();
        xmlDebug.open("GET", url_debug+"CardListshow_ok:"+defaultVideo, false);
        xmlDebug.send();
    }
    catch(e)
    {
        xmlDebug = new XMLHttpRequest();
        xmlDebug.open("GET", url_debug+"CardListshow_Error:"+e, false);
        xmlDebug.send();
    }

}
// 20140323 willy ------

// 20140326 willy build59 ---延遲的function---
function sleep(ms)
{

    var starttime= new Date().getTime();

    do{

    }while((new Date().getTime()-starttime)<ms)

        }
// 20140326 willy ------

// 20140329 willy build63 ---燈號控制---
function Light_Pause()// 暫停燈
{
    var tmpButton = document.getElementById('pause');
    tmpButton.setAttribute('class', 'selected');
    tmpButton = document.getElementById('play');
    tmpButton.setAttribute('class', 'unselected');
    tmpButton = document.getElementById('backtrack');
    tmpButton.setAttribute('class', 'unselected');
}

function Light_Play()// 播放燈
{
    var tmpButton = document.getElementById('pause');
    tmpButton.setAttribute('class', 'unselected');
    tmpButton = document.getElementById('play');
    tmpButton.setAttribute('class', 'selected');
    tmpButton = document.getElementById('backtrack');
    tmpButton.setAttribute('class', 'unselected');
}

function Light_Backtrack()// 倒播燈
{
    var tmpButton = document.getElementById('pause');
    tmpButton.setAttribute('class', 'unselected');
    tmpButton = document.getElementById('play');
    tmpButton.setAttribute('class', 'unselected');
    tmpButton = document.getElementById('backtrack');
    tmpButton.setAttribute('class', 'selected');
}
// 20140329 willy ------

// 20140330 willy build65 ---網頁版的loading圖示---
function showLoadWeb() {
    //document.getElementById("loading").innerHTML = "正在加載";
    document.getElementById("loading_img").style.display = "block";
    document.getElementById("loading_msg").style.display = "block";
    FStaut=false;
}

function hideLoadWeb() {
    //document.getElementById("loading").innerHTML = "正在加載";
    document.getElementById("loading_img").style.display = "none";
    document.getElementById("loading_msg").style.display = "none";
    FStaut=true;
}
// 20140330 willy ------

// 20140330 willy build64 ---播放影片---
function playVideo(src)
{
    try
    {
        sleep(800);
        hideLoadWeb();// 20140330 willy build64 ---隱藏loading圖示---
        //  103.3.20 arthur nowPath = 當前檔案路徑
        nowPath = src;
        setSubPath = src.replace("main","sub");

        xmlDebug = new XMLHttpRequest();
        xmlDebug.open("GET", url_debug+"video_create2:"+src, false);
        xmlDebug.send();
        // 20140320 林宏 ---------

        isPlayVideo = true;

        var isVideoAlreayHere;

        // Debug : display video name
        var xmlD;
        xmlD = new XMLHttpRequest();
        xmlD.open("GET", url_copy_TSFile+"src"+src, false);
        xmlD.send(null);

        var old_last = last_video_update;

        last_video_update = 0;

        //deferred_seek = 0;// 20140402 willy build72 ---倒播不能為０---

        compute_current_offset();

        if(typeof(videoElement) != 'undefined')
        {
            isVideoAlreayHere = true;

        }
        else
        {
            isVideoAlreayHere = false;
        }

        if(isVideoAlreayHere)
        {
            //2014.3.23 播放元件的創立與判斷
            if((src.search("/Documents/tmpvideo/") !=-1) || (src.search("/Documents/diskvideo/") !=-1))//if((src.search("main") !=-1 || setSubPath.search("sub") !=-1 ))
            {
                OC_CopyFileBtn_Hide();// 20140331 willy build68 ---隱藏聲音鈕---
                if(src.search("main") !=-1)
                {

                    videoElement.setAttribute('src', src);
                    videoElement.load();
                    videoElement.play();    // Need to be called before seek_video, otherwise error INVALID_STATE_ERR: DOM Exception 11

                    subVideoElement.setAttribute('src',setSubPath);
                    subVideoElement.load();
                    subVideoElement.play();
                    subVideo.appendChild(subVideoElement);

                }

                var _sd = 1;
                var xmlSD;
                xmlSD = new XMLHttpRequest();
                xmlSD.open("GET", url_check+_sd, false);
                xmlSD.send(null);
            }
            else
            {
                OC_CopyFileBtn_Show();// 20140331 willy build68 ---顯示聲音鈕---

                videoElement.setAttribute('src', src);
                videoElement.load();
                videoElement.play();

                subVideoElement.setAttribute('src',"");
                subVideo.removeChild(subVideoElement);

                var _sdx = 0;
                var xmlTS;
                xmlTS = new XMLHttpRequest();
                xmlTS.open("GET", url_check+_sdx, false);
                xmlTS.send(null);

            }

        }
        else
        {
            var debugxml = new XMLHttpRequest();
            debugxml.open("GET", url_debug+"video_create_subPath:"+setSubPath, false);
            debugxml.send();

            // 20140401 willy build71 ---進入page3調整畫面---
            document.getElementById('commande').style.marginTop="-50px";
            //            document.getElementById('subBlueView').style.marginTop="-450px";

            videoElement = document.createElement('video');
            videoElement.setAttribute('src', src);
            videoElement.setAttribute('id', 'video');
            videoElement.setAttribute('control', '');
            videoElement.autoplay = true;
            video.appendChild(videoElement);

            //2014.3.23 小碼流元件創立
            subVideoElement = document.createElement('video');
            subVideoElement.setAttribute('id', 'subVideo');
            subVideoElement.setAttribute('control', '');
            subVideoElement.autoplay = true;
            if(typeEO5 == "1")
            {
                mainView();
            }

            // 20140324 willy build56 ---改由main.js處理---
            if((src.search("/Documents/tmpvideo/") !=-1) || (src.search("/Documents/diskvideo/") !=-1))
            {
                //videoElement.setAttribute('src', src);
                subVideoElement.setAttribute('src', setSubPath);

            }

            //video.appendChild(videoElement);
            subVideo.appendChild(subVideoElement);

            var _sdx = 0;
            var xmlTS;
            xmlTS = new XMLHttpRequest();
            xmlTS.open("GET", url_check+_sdx, false);
            xmlTS.send(null);



            // 20140324 willy ------
        }

        // 20140327 willy build61 ---播放速率的燈號轉換---
        //video_playbackrate(current_speed);
        video_playbackrate(1);


        if(!isVideoAlreayHere)
        {
            videoElement.addEventListener('timeupdate', video_timeupdate, false);   //timeupdate : currentTime was changed
            videoElement.addEventListener('ended', video_ended, false);         //ended : video has ended
            videoElement.addEventListener('seeked', event_seeked, false);       //seeked : seeking is true(browser seeks a position)
            //videoElement.addEventListener('seeking', event_seeked, false);       //seeking : seeking is now false(position found)
            videoElement.addEventListener('playing', event_playing, false);     //playing : playback started

            videoElement.addEventListener('loadedmetadata', function() {        //loadedmetadata : metadata loaded
                                          // Calculate the ratio of the video's width to height
                                          ratio = videoElement.videoWidth / videoElement.videoHeight;
                                          // Define the required width as 100 pixels smaller than the actual video's width
                                          w = videoElement.videoWidth - 100;
                                          // Calculate the height based on the video's width and the ratio
                                          h = parseInt(w / ratio, 10);
                                          // Set the canvas width and height to the values just calculated
                                          //canvas.width = w;
                                          //canvas.height = h;
                                          }, false);


            // 20140430 willy build80 ---檢查Player播放狀態---
            videoElement.addEventListener('pause', video_pause, false);// 暫停的燈號顯示
            videoElement.addEventListener('volumechange', fullmain_volume_changed, false);// 音量的控制
            subVideoElement.addEventListener('volumechange', fullsub_volume_changed, false);// 音量的控制
            //            subVideoElement.addEventListener('seeked', sub_event_seeked, false);// 拖拉bar的影像同步
            // 20140430 willy ------

            /*
             //2014.3.23 小碼流視窗尺寸
             subVideoElement.addEventListener('timeupdate', video_timeupdate, false);
             subVideoElement.addEventListener('ended', video_ended, false);
             subVideoElement.addEventListener('seeked', event_seeked, false);
             subVideoElement.addEventListener('playing', event_playing, false);
             */
            //            subVideoElement.addEventListener('play', video_play, false);
            //            subVideoElement.addEventListener('pause', video_pause, false);
            subVideoElement.addEventListener('loadedmetadata', function() {
                                             sub_ratio = subVideoElement.videoWidth / subVideoElement.videoHeight;
                                             sub_w = subVideoElement.videoWidth - 100;
                                             sub_h = parseInt(sub_w / sub_ratio, 10);
                                             //sub_canvas.width = sub_w;
                                             //sub_canvas.height = sub_h;
                                             }, false);

            subVideoElement.addEventListener('canplay',set_Sub_Main_View , false);
            subVideoElement.addEventListener('error',onlyMainView , false);

        }
        videobackward=false;// 20140402 willy build72 ---因手動倒播而造成換擋---
        videobacktrack_end=false;// 20140408 willy build72 ---用於判斷倒播是否結束---

    }
    catch(e)
    {
        xmlDebug = new XMLHttpRequest();
        xmlDebug.open("GET", url_debug+"playvideo_Error:"+e, false);
        xmlDebug.send();
    }
}
// 20140330 willy ------

function getPosition(element)
{
    var xPosition = 0;
    var yPosition = 0;

    while (element)
    {
        xPosition += (element.offsetLeft - element.scrollLeft + element.clientLeft);
        yPosition += (element.offsetTop - element.scrollTop + element.clientTop);
        element = element.offsetParent;
    }
    return { x: xPosition, y: yPosition };
}

function click_bar_down(event)
{
    try
    {
        if(!FStaut)
        {
            return;
        }

        var xmlDebug = new XMLHttpRequest();
        xmlDebug.open("GET", url_debug+"click_bar_down", false);
        xmlDebug.send();


        isMouseDown = true;
        videoElement.pause();
        subVideoElement.pause();
        showLoadWeb();
        reset_map();
        isTrackButtonMoving = 1;

        var parentPosition = getPosition(event.currentTarget); //getPosition(track)
        var off_X = event.clientX - parentPosition.x - (trackbutton.clientWidth / 2);
        var y=event.clientY - parentPosition.y - (trackbutton.clientHeight / 2);

        trackbutton.style.webkitTransform = "translateX("+off_X+"px)";

        document.onmouseup = function()
        {
            isMouseUp = true;
            document.onmousemove = null;

            isTrackButtonMoving = 0;

            if(off_X >= tracksize - 1)
            {
                off_X = tracksize - 1.2;
            }

            var tmp = off_X / px_per_sec;

            if(tmp < offset_current_video)
            {
                // Before the current track
                video_position_outside_current_track(tmp);
                document.onmouseup = null;
                trackbutton.style.webkitTransform = "translateX("+off_X+"px)";
                if(off_X < 0)
                {
                    trackbutton.style.webkitTransform = "translateX("+0+"px)";
                }

                return;
            }

            if(playlist_pos != -1)
            {
                var xmla = new XMLHttpRequest();
                xmla.open("GET", url_debug+"playlist_pos_x1", false);
                xmla.send();

                if(tmp > offset_current_video + parseInt(ts_duration[playlist_pos]))
                {
                    var xmla = new XMLHttpRequest();
                    xmla.open("GET", url_debug+"playlist_pos_x2", false);
                    xmla.send();

                    isClickToNextFile = true;

                    // After the current track
                    video_position_outside_current_track(tmp);
                    document.onmouseup = null;

                    trackbutton.style.webkitTransform = "translateX("+off_X+"px)";
                    if(off_X > tracksize)
                    {
                        trackbutton.style.webkitTransform = "translateX("+tracksize+"px)";
                    }
                    return;
                }
            }

            seek_video(videoElement, tmp - offset_current_video);
            document.onmouseup = null;
        }

    }
    catch(e)
    {
        var xmlDebug = new XMLHttpRequest();
        xmlDebug.open("GET", url_debug+"click_bar_down_Error="+e, false);
        xmlDebug.send();
    }

}


function getScreen_Width(sWidth)
{
    screenW = sWidth;
}

function getScreen_Height(sHeight)
{
    screenH = sHeight;
}

function video_Fullscreen_Size()
{
    var control = document.getElementById('commande');
    var main = document.getElementById('video_placeholder');
    var sub = document.getElementById('subView');

    if(screenW <= 1600)
    {
        videoElement.style.height = 1010+"px";
        videoElement.style.width = 1310+"px";

        var xmlDebug = new XMLHttpRequest();
        xmlDebug.open("GET", url_debug+"fullScreen_size_1600", false);
        xmlDebug.send();

        if(getMainView)
        {
            control.style.left = -65+"px";
            control.style.top = 320+"px";
            control.style.width = "945px";
            control.style.height = "18px";
            control.style.borderRadius = '1em';

            main.style.left = 15+"px";
            main.style.top = -950+"px";

        }
        else if(createSubView)
        {
            control.style.left = -220+"px";
            control.style.top = 320+"px";
            control.style.width = "940px";
            control.style.height = "18px";
            control.style.borderRadius = '1em';

            main.style.left = 15+"px";
            main.style.top = -950+"px";

            subVideoElement.style.width = 390 + "px";
            subVideoElement.style.height = 260 + "px";
            subVideoElement.style.left = -6 + "px";
            subVideoElement.style.top = -1365 + "px";

        }
        else if(typeEO5 == "1")
        {
            control.style.left = -65+"px";
            control.style.top = 320+"px";
            control.style.width = "945px";
            control.style.height = "18px";
            control.style.borderRadius = '1em';

            main.style.left = 15+"px";
            main.style.top = -950+"px";

        }

        document.getElementById('loading_img').style.left = 75+"px";
        document.getElementById('loading_img').style.top = -150+"px";
        document.getElementById('loading_msg').style.left = 75+"px";
        document.getElementById('loading_msg').style.top = -150+"px";

    }
    else //if(screenW >1600)
    {
        videoElement.style.height = 902+"px";
        videoElement.style.width = 1920+"px";

        var xmlDebug = new XMLHttpRequest();
        xmlDebug.open("GET", url_debug+"fullScreen_size:1920", false);
        xmlDebug.send();

        if(getMainView)
        {
            if(osx10_9)
            {
                document.getElementById('loading_img').style.left = 240+"px";//(screenW/2 - 480)+"px";
                document.getElementById('loading_img').style.top = -450+"px";//(screenH/2 -350)+"px";
                document.getElementById('loading_msg').style.left = 240+"px";
                document.getElementById('loading_msg').style.top = -450+"px";
            }
            else
            {
                document.getElementById('loading_img').style.left = 240+"px";//(screenW/2 - 480)+"px";
                document.getElementById('loading_img').style.top = -150+"px";//(screenH/2 -350)+"px";
                document.getElementById('loading_msg').style.left = 240+"px";
                document.getElementById('loading_msg').style.top = -150+"px";
            }

            control.style.left = 200+"px";
            control.style.top = 408+"px";
            control.style.width = "950px";
            control.style.height = "20px";
            control.style.borderRadius = '1em';

            main.style.left = 5+"px";
            main.style.top = -950+"px";

        }
        else if(createSubView)
        {
            if(osx10_9)
            {
                document.getElementById('loading_img').style.left = 240+"px";//(screenW/2 - 480)+"px";
                document.getElementById('loading_img').style.top = -450+"px";//(screenH/2 -350)+"px";
                document.getElementById('loading_msg').style.left = 240+"px";
                document.getElementById('loading_msg').style.top = -450+"px";
            }
            else
            {
                document.getElementById('loading_img').style.left = 240+"px";//(screenW/2 - 480)+"px";
                document.getElementById('loading_img').style.top = -150+"px";//(screenH/2 -350)+"px";
                document.getElementById('loading_msg').style.left = 240+"px";
                document.getElementById('loading_msg').style.top = -150+"px";
            }


            control.style.left = 155+"px";
            control.style.top = 410+"px";
            control.style.width = "950px";
            control.style.height = "20px";
            control.style.borderRadius = '1em';

            main.style.left = 5+"px";
            main.style.top = -950+"px";

            subVideoElement.style.width = 420 + "px";
            subVideoElement.style.height = 260 + "px";
            subVideoElement.style.left = -130 + "px";
            subVideoElement.style.top = -1230 + "px";
        }
        else if(typeEO5 == "1")
        {
            if(osx10_9)
            {
                document.getElementById('loading_img').style.left = 240+"px";//(screenW/2 - 480)+"px";
                document.getElementById('loading_img').style.top = -450+"px";//(screenH/2 -350)+"px";
                document.getElementById('loading_msg').style.left = 240+"px";
                document.getElementById('loading_msg').style.top = -450+"px";
            }
            else
            {
                document.getElementById('loading_img').style.left = 240+"px";//(screenW/2 - 480)+"px";
                document.getElementById('loading_img').style.top = -150+"px";//(screenH/2 -350)+"px";
                document.getElementById('loading_msg').style.left = 240+"px";
                document.getElementById('loading_msg').style.top = -150+"px";
            }

            control.style.left = 200+"px";
            control.style.top = 408+"px";
            control.style.width = "950px";
            control.style.height = "20px";
            control.style.borderRadius = '1em';

            main.style.left = 5+"px";
            main.style.top = -950+"px";
        }

    }

}

function restore_Screen()
{
    if(isMouseUp)
    {
        return;
    }

    isRestoreScreen = true;
    isFullScreen = false;

    var xmlreqDebug = new XMLHttpRequest();
    xmlreqDebug.open("GET", url_restore_view, false);
    xmlreqDebug.send(null);

    var main = document.getElementById('video_placeholder');
    var control = document.getElementById('commande');

    if(screenW <= 1600)
    {
        var xmlreqDebug = new XMLHttpRequest();
        xmlreqDebug.open("GET", url_debug+"RestoreScreen_1599", false);
        xmlreqDebug.send(null);

        document.getElementById('mail').style.visibility = 'visible';
        document.getElementById('fullscreen').style.visibility = 'visible';
        document.getElementById('save').style.visibility = 'visible';
        document.getElementById('map_canvas').style.visibility = 'visible';
        document.getElementById('sd_frame').style.visibility = 'visible';
        document.getElementById('disk2_frame').style.visibility = 'visible';
        document.getElementById('fichier').style.visibility = 'visible';
        document.getElementById('disk_frame').style.visibility = 'visible';
        document.getElementById('speed').style.visibility = 'visible';
        document.getElementById('data').style.visibility = 'visible';
        document.getElementById('menu_bar').style.visibility = 'visible';
        document.getElementById('grid2').style.visibility = 'visible';
        document.getElementById('restore_icon').style.display = "none";


        if(getMainView)
        {
            videoElement.style.height = 655+"px";
            videoElement.style.width = 810+"px";
            main.style.left = 350+"px";
            main.style.top = -782+"px";

            control.style.left = 1+"px";
            control.style.top = -2+"px";
            control.style.width = "1052px";
            control.style.height = "20px";
            control.style.borderRadius = '0em';

            document.getElementById('loading_img').style.left = 180 +"px";
            document.getElementById('loading_img').style.top = -350+"px";
            document.getElementById('loading_msg').style.left = 180+"px";
            document.getElementById('loading_msg').style.top = -350+"px";
        }
        else if(createSubView)
        {
            videoElement.style.height = 590+"px";
            videoElement.style.width = 750+"px";

            main.style.left = 245+"px";
            main.style.top = -766+"px";

            subVideoElement.style.left = -7 + "px";
            subVideoElement.style.top = -1120 + "px";
            subVideoElement.style.height = 270+"px";
            subVideoElement.style.width = 285+"px";

            control.style.left = 1+"px";
            control.style.top = -2+"px";
            control.style.width = "1052px";
            control.style.height = "20px";
            control.style.borderRadius = '0em';

            document.getElementById('loading_img').style.left = 80 +"px";
            document.getElementById('loading_img').style.top = -350+"px";
            document.getElementById('loading_msg').style.left = 80+"px";
            document.getElementById('loading_msg').style.top = -350+"px";
        }
        else if(typeEO5 == "1")
        {
            videoElement.style.height = 655+"px";
            videoElement.style.width = 810+"px";
            main.style.left = 350+"px";
            main.style.top = -782+"px";

            control.style.left = 1+"px";
            control.style.top = -2+"px";
            control.style.width = "1052px";
            control.style.height = "20px";
            control.style.borderRadius = '0em';

            document.getElementById('loading_img').style.left = 180 +"px";
            document.getElementById('loading_img').style.top = -350+"px";
            document.getElementById('loading_msg').style.left = 180+"px";
            document.getElementById('loading_msg').style.top = -350+"px";
        }

    }
    else //if(screenW >1600)
    {
        setTimeout(showPartUI,5);

        var xmlreqDebug = new XMLHttpRequest();
        xmlreqDebug.open("GET", url_debug+"RestoreScreen_1920", false);
        xmlreqDebug.send(null);
        var sub = document.getElementById('subView');

        if(getMainView)
        {
            setTimeout(showMain,5);
            if(osx10_9)
            {
                //                main.style.left = 350+"px";
                //                main.style.top = -845+"px";
                setTimeout(showMainView_osx10_9,5);

                document.getElementById('loading_img').style.left = 180 +"px";
                document.getElementById('loading_img').style.top = -500+"px";
                document.getElementById('loading_msg').style.left = 180+"px";
                document.getElementById('loading_msg').style.top = -500+"px";

            }
            else
            {
                //                main.style.left = 350+"px";
                //                main.style.top = -782+"px";
                setTimeout(showMainView_osx10_8,5);
                document.getElementById('loading_img').style.left = 180 +"px";
                document.getElementById('loading_img').style.top = -350+"px";
                document.getElementById('loading_msg').style.left = 180+"px";
                document.getElementById('loading_msg').style.top = -350+"px";
            }

        }
        else if(createSubView)
        {
            setTimeout(showSub,5);

            if(osx10_9)
            {
                setTimeout(showSubView_osx10_9,5);
                document.getElementById('loading_img').style.left = 80 +"px";
                document.getElementById('loading_img').style.top = -500+"px";
                document.getElementById('loading_msg').style.left = 80+"px";
                document.getElementById('loading_msg').style.top = -500+"px";

            }
            else
            {
                setTimeout(showSubView_osx10_8,5);

                document.getElementById('loading_img').style.left = 80 +"px";
                document.getElementById('loading_img').style.top = -350+"px";
                document.getElementById('loading_msg').style.left = 80+"px";
                document.getElementById('loading_msg').style.top = -350+"px";

            }
        }
        else if(typeEO5 == "1")
        {
            setTimeout(showEO5Main,5);

            if(osx10_9)
            {
                //                main.style.left = 350+"px";
                //                main.style.top = -845+"px";
                setTimeout(showEO5Main_osx10_9,5);
                document.getElementById('loading_img').style.left = 180 +"px";
                document.getElementById('loading_img').style.top = -500+"px";
                document.getElementById('loading_msg').style.left = 180+"px";
                document.getElementById('loading_msg').style.top = -500+"px";
            }
            else
            {
                //                main.style.left = 350+"px";
                //                main.style.top = -782+"px";
                setTimeout(showEO5Main_osx10_8,5);
                document.getElementById('loading_img').style.left = 180 +"px";
                document.getElementById('loading_img').style.top = -350+"px";
                document.getElementById('loading_msg').style.left = 180+"px";
                document.getElementById('loading_msg').style.top = -350+"px";
            }

        }

    }


    if(isPlay && !isPause)
    {
        videoElement.play();
    }

    if(!isMouseUp && isPause && !isClickToNextFile )
    {
        setTimeout(pauseToPlay,10);
    }

    if(isMouseUp &&  !isPause && !isClickToNextFile)
    {
        videoElement.play();
    }

    if(isMouseUp  &&  isPause && !isClickToNextFile )
    {
        setTimeout(pauseToPlay,10);
    }

    if(isMouseUp && isClickToNextFile &&  isPause == false)
    {
        videoElement.play();
    }

    if(isMouseUp && isClickToNextFile &&  isPause )
    {
        setTimeout(pauseToPlay,10);
    }

    //    if(screenW <= 1600)
    //    {
    //        document.getElementById('loading_img').style.left = (screenW/2 - 450)+"px";
    //        document.getElementById('loading_img').style.top = (screenH/2 -440)+"px";
    //        document.getElementById('loading_msg').style.left = (screenW/2 -450)+"px";
    //        document.getElementById('loading_msg').style.top = (screenH/2 -440)+"px";
    //    }

}

function set_Sub_Main_View()
{
    if(isFullScreen)
    {
        return;
    }
    createSubView = true;
    getMainView = false;
    sub_MainView();
}

function onlyMainView()
{
    if(isFullScreen)
    {
        return;
    }
    getMainView = true;
    createSubView = false;
    mainView();
}

function sub_MainView()
{
    videoElement.style.height = 590+"px";
    videoElement.style.width = 750+"px";
    var main = document.getElementById('video_placeholder');

    if(osx10_9)
    {
        main.style.left = 244+"px";
        main.style.top = -830+"px";

        subVideoElement.style.height = 270+"px";
        subVideoElement.style.width = 285+"px";
        subVideoElement.style.left = -8 + "px";
        subVideoElement.style.top = -1185 + "px";
        
        document.getElementById('loading_img').style.left = 80 +"px";
        document.getElementById('loading_img').style.top = -500+"px";
        document.getElementById('loading_msg').style.left = 80+"px";
        document.getElementById('loading_msg').style.top = -500+"px";
        
    }
    else
    {
        main.style.left = 244+"px";
        main.style.top = -766+"px";
        
        //    subVideoElement.style.height = 590+"px";
        //    subVideoElement.style.width = 750+"px";
        //    subVideoElement.style.left = 130 + "px";
        //    subVideoElement.style.top = -1088 + "px";
        
        document.getElementById('loading_img').style.left = 80 +"px";
        document.getElementById('loading_img').style.top = -350+"px";
        document.getElementById('loading_msg').style.left = 80+"px";
        document.getElementById('loading_msg').style.top = -350+"px";
        
    }
    
}

function mainView()
{
    videoElement.style.height = 655+"px";
    videoElement.style.width = 810+"px";
    
    //    videoElement.style.marginTop = -15+"px";
    //    videoElement.style.marginLeft = 20+"px";
    //    videoElement.style.left = 350+"px";
    //    videoElement.style.top = -1000+"px";
    
    var main = document.getElementById('video_placeholder');
    if(osx10_9)
    {
        main.style.left = 350+"px";
        main.style.top = -845+"px";
        document.getElementById('loading_img').style.left = 180 +"px";
        document.getElementById('loading_img').style.top = -500+"px";
        document.getElementById('loading_msg').style.left = 180+"px";
        document.getElementById('loading_msg').style.top = -500+"px";
    }
    else
    {
        main.style.left = 350+"px";
        main.style.top = -782+"px";
        
        document.getElementById('loading_img').style.left = 180 +"px";
        document.getElementById('loading_img').style.top = -350+"px";
        document.getElementById('loading_msg').style.left = 180+"px";
        document.getElementById('loading_msg').style.top = -350+"px";
        
    }
    
}

function escToRestore(keyEvent)
{
    var pressedKeyValue = keyEvent.keyCode;
    if(pressedKeyValue == 27)
    {
        restore_Screen();
    }
}

function showPartUI()
{
    document.getElementById('mail').style.visibility = 'visible';
    document.getElementById('fullscreen').style.visibility = 'visible';
    document.getElementById('save').style.visibility = 'visible';
    document.getElementById('map_canvas').style.visibility = 'visible';
    document.getElementById('sd_frame').style.visibility = 'visible';
    document.getElementById('disk2_frame').style.visibility = 'visible';
    document.getElementById('fichier').style.visibility = 'visible';
    document.getElementById('disk_frame').style.visibility = 'visible';
    document.getElementById('speed').style.visibility = 'visible';
    document.getElementById('data').style.visibility = 'visible';
    document.getElementById('menu_bar').style.visibility = 'visible';
    document.getElementById('grid2').style.visibility = 'visible';
    document.getElementById('restore_icon').style.display = "none";
}

function showMain()
{
    var control = document.getElementById('commande');
    videoElement.style.height = 655+"px";
    videoElement.style.width = 810+"px";
    control.style.left = 1+"px";
    control.style.top = -2+"px";
    control.style.width = "1052px";
    control.style.height = "20px";
    control.style.borderRadius = '0em';
}

function showSub()
{
    var control = document.getElementById('commande');
    videoElement.style.height = 590+"px";
    videoElement.style.width = 750+"px";
    
    control.style.left = 1+"px";
    control.style.top = -2+"px";
    control.style.width = "1052px";
    control.style.height = "20px";
    control.style.borderRadius = '0em';
}

function showEO5Main()
{
    var control = document.getElementById('commande');
    videoElement.style.height = 655+"px";
    videoElement.style.width = 810+"px";
    control.style.left = 1+"px";
    control.style.top = -2+"px";
    control.style.width = "1052px";
    control.style.height = "20px";
    control.style.borderRadius = '0em';
    
}


function showMainView_osx10_9()
{
    var main = document.getElementById('video_placeholder');
    main.style.left = 350+"px";
    main.style.top = -845+"px";
}

function showMainView_osx10_8()
{
    var main = document.getElementById('video_placeholder');
    main.style.left = 350+"px";
    main.style.top = -782+"px";
}

function showSubView_osx10_9()
{
    var main = document.getElementById('video_placeholder');
    main.style.left = 244+"px";
    main.style.top = -830+"px";
    
    subVideoElement.style.left = -8 + "px";
    subVideoElement.style.top = -1185 + "px";
    subVideoElement.style.height = 270+"px";
    subVideoElement.style.width = 285+"px";
}

function showSubView_osx10_8()
{
    var main = document.getElementById('video_placeholder');
    main.style.left = 245+"px";
    main.style.top = -766+"px";
    
    subVideoElement.style.left = -7 + "px";
    subVideoElement.style.top = -1120 + "px";
    subVideoElement.style.height = 270+"px";
    subVideoElement.style.width = 285+"px";
    
}

function showEO5Main_osx10_9()
{
    var main = document.getElementById('video_placeholder');
    main.style.left = 350+"px";
    main.style.top = -845+"px";
}

function showEO5Main_osx10_8()
{
    var main = document.getElementById('video_placeholder');
    main.style.left = 350+"px";
    main.style.top = -782+"px";
}

function pauseToPlay()
{
    videoElement.play();
    videoElement.pause();
}

function getUSBState()
{
    var xmlreqDebug = new XMLHttpRequest();
    xmlreqDebug.open("GET", url_chk_usb_state, false);
    xmlreqDebug.send(null);
}

function usbState(state)
{
    SDCard_plugging = state;
    
}

function cancelAPP()
{
    var terminate = new XMLHttpRequest();
    terminate.open("GET", url_remove_usb, false);
    terminate.send(null);
}


function get_USBLose_OpenFile_state()
{
    var detect911 = new XMLHttpRequest();
    detect911.open("GET", url_lose_usb_openfile, false);
    detect911.send(null);

}

function usbLoseAndOpenFile(lose)
{
    openFile_loseUSB = lose;
}